﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
//using System.Windows.Forms;
//using MathNet.Numerics.IntegralTransforms;
//using MathNet.Numerics;
//using MathNet.Numerics.LinearAlgebra;
//using MathNet.Numerics.Signals;
//using MathNet.Numerics.IntegralTransforms.Algorithms;
//using MathNet.Numerics.LinearAlgebra.Complex;
//using System.Numerics;

//namespace Climate_toolkit
//{
//    class CPeriodicAnalysisFactory
//    {
//        private Cdatamaster datamaster;
//        private string selecteddataseries; // this is only for the preprocessing tasks
//        private string selecteddataseries_interpolated;

//        public CPeriodicAnalysisFactory(Cdatamaster datamasterToUse, string selecteddataseriesToUse)
//        {
//            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
//            this.selecteddataseries = selecteddataseriesToUse;
//        }

//        public class CFourierAnalysisFactory
//        {
//            public static double[] get_fft(double[] x)
//            {
//                double[] y = new double[x.Length];

//                Complex[] samples = new Complex[x.Length];
//                for (int i = 0; i < x.Length; i++)
//                {
//                    samples[i] = x[i];
//                }

//                //var samples = SignalGenerator.EquidistantPeriodic(w => new Complex(Math.Sin(w), 0), Constants.Pi2, 0, 16);
//                //Console.WriteLine(samples);
//                var dft = new DiscreteFourierTransform();
//                //dft.BluesteinForward(samples, FourierOptions.Matlab);
//                var spectrum = dft.NaiveForward(samples, FourierOptions.Matlab);
//                //double spec_double = spectrum.to;
//                //double spectrum_mean  = CStatsFactory.get_mean(spectrum.ToArray());

//                //CStatsFactory.get_z_score(spectrum.ToArray,

//                double[] spec = new double[x.Length];
//                int j = 0;
//                foreach (Complex value in spectrum)
//                {
//                    //Console.WriteLine("Original value: {0}", value);
//                    //Console.WriteLine("Conjugate:      {0}\n",
//                    //                  Complex.Conjugate(value).ToString());
//                    Console.WriteLine("|{0}| = {1:N2}", value, Complex.Abs(value));

//                    spec[j] = Complex.Abs(value);
//                    j++;
//                }

//                return spec;

//            }

//            public static double[] get_spectrum_scale_to_one(double[] y)
//            {
//                double[] scaled_spectrum = new double[y.Length];
//                double sum = 0;
//                for (int i = 0; i < y.Length; i++)
//                {
//                    sum = sum + y[i];
//                }

//                for (int i = 0; i < y.Length; i++)
//                {
//                    scaled_spectrum[i] = y[i] / sum;
//                }
//                return scaled_spectrum;
//            }
  
//            public static double[] get_fft_by_coefficients(double[] data, double delt, double T)
//            {


//                int N = data.Length;
//                double Num = Convert.ToDouble(N);

//                // check for odd number of points
//                //if (data.Length % 2 > 0)
//                //{
//                //    odd = true;
//                //    // in the domain [0 T], 0 and T coincide with i = 1 and i = N - 1
//                //    N = data.Length - 1;
//                //    Num = Convert.ToDouble(N);
//                //}

//                double[] y = new double[N];


//                {
//                    for (int i = 0; i < N; i++)
//                    {
//                        y[i] = data[i];
//                    }
//                }


//                double[] k = new double[N / 2];
//                double[] index = new double[N];
//                double Asum = 0;
//                double Bsum = 0;

//                double[] A = new double[N / 2];
//                double[] B = new double[N / 2];
//                double[] C = new double[N / 2];

//                double[] spectral_power = new double[N / 2];

//                // assign k's
//                for (int i = 0; i < N / 2; i++)
//                {
//                    if (i == 0)
//                    {
//                        k[i] = 1;
//                    }
//                    else
//                    {
//                        k[i] = k[i - 1] + 1;
//                    }
//                }

//                for (int i = 0; i < N; i++)
//                {
//                    if (i == 0)
//                    {
//                        index[i] = 1;
//                    }
//                    else
//                    {
//                        index[i] = index[i - 1] + 1;
//                    }
//                }

//                // assign i index


//                for (int j = 0; j < (N / 2); j++)
//                {
//                    if (j != N / 2)
//                    {
//                        for (int i = 0; i < Num; i++)
//                        {
//                            if (i == 0)
//                            {
//                                Asum = y[i] * Math.Cos(2 * Math.PI * k[j] * (index[i] * delt / T));
//                                Bsum = y[i] * Math.Sin(2 * Math.PI * k[j] * (index[i] * delt / T));
//                            }
//                            else
//                            {
//                                Asum = Asum + y[i] * Math.Cos(2 * Math.PI * k[j] * (index[i] * delt / T));
//                                Bsum = Bsum + y[i] * Math.Sin(2 * Math.PI * k[j] * (index[i] * delt / T));
//                            }
//                        }
//                        A[j] = 2 / Num * Asum;
//                        B[j] = 2 / Num * Bsum;
//                    }
//                    else // j (or "k") = N/2
//                    {
//                        for (int i = 0; i < Num; i++)
//                        {
//                            if (i == 0)
//                            {
//                                Asum = y[i] * Math.Cos(Math.PI * Num * (delt / T));
//                                Bsum = 0;
//                            }
//                            else
//                            {
//                                Asum = Asum + y[i] * Math.Cos(Math.PI * Num * (delt / T));
//                                Bsum = 0;
//                            }
//                        }
//                        A[j] = 1 / Num * Asum;
//                        B[j] = 0;
//                    }
//                    C[j] = Math.Sqrt(Math.Pow(A[j], 2) + Math.Pow(B[j], 2));
//                    spectral_power[j] = Math.Pow(C[j], 2) / 2;

//                }

//                return spectral_power;

//            }

//            public static double get_spectrum_dof(double[] x, double[] spectrum, double fw)
//            {
//                double dof;
//                dof = 2;

//                return dof;
//            }

//            public static double[] get_theoretical_power_spectrum(double[] x, double delt, double[] spectrum)
//            {
//                // first get frequencies
//                double[] omega = new double[spectrum.Length];
//                double[] k = new double[spectrum.Length];

//                double num = Convert.ToDouble(x.Length);

//                // assign k's
//                for (int i = 0; i < spectrum.Length; i++)
//                {
//                    if (i == 0)
//                    {
//                        k[i] = 1;
//                    }
//                    else
//                    {
//                        k[i] = k[i - 1] + 1;
//                    }
//                }

//                for (int j = 0; j < spectrum.Length; j++)
//                {
//                    omega[j] = 2 * Math.PI * k[j] / (num-1);
//                }

//                // then get e-folding length T
//                // get lag-1 autocorrelation a
//                double[] a = new double[2];
//                a = CStatsFactory.get_autocorrelation_function(x, 1);
//                double T = -delt / Math.Log(a[1]);

//                double[] iota = new double[spectrum.Length];

//                for (int i = 0; i < spectrum.Length; i++)
//                {
//                    iota[i] = (2 * T) / (1 + Math.Pow(T, 2) * Math.Pow(omega[i], 2));
//                }
//                return iota;



//            }

//            public static double[] get_sig_spectrum_chisquared(double[] x, double[] rednoisespectrum, int numsmoothingwindow, int numrealizations, double y)
//            {
//                double[] sig_spectrum = new double[rednoisespectrum.Length];
//                int v; // degrees of freedom
//                //double fw = 1.0;
//                //if (hanning)
//                //{
//                //    fw = 1.2; // from Hartmann notes
//                //}

//                int M = rednoisespectrum.Length*numsmoothingwindow*numrealizations;
//                v = x.Length / M; // could multiply by fw to account for smoothing
                
//                double critical_value = CHypothesisTestingFactory.get_Chisquared_sig_level(v, y);
                

//                for (int i = 0; i < rednoisespectrum.Length; i++)
//                {
//                    sig_spectrum[i] = rednoisespectrum[i] * critical_value;
//                }

//                return sig_spectrum;
//            }

//            public static double[] get_spectrum_F_statistic(double[] spectrum, double[] red_noise)
//            {
//                // use F statistic
//                double[] F = new double[spectrum.Length];

//                for (int i = 0; i < spectrum.Length; i++)
//                {
//                    F[i] = spectrum[i] / red_noise[i];

//                }
//                return F;
//            }

//            public static double[] get_boxcar_window(double[] x)
//            {
//                double[] boxcar = new double[x.Length];
//                double T = x.Length;

//                for (int i = 0; i < x.Length; i++)
//                {
//                    boxcar[i] = x[i]/ T;
//                }

//                return boxcar;
//            }

//            public static double[] get_hann_windowed_ts(double[] x)
//            {
//                double[] w = new double[x.Length];
//                double[] hann = new double[x.Length];
//                double T = x.Length;
//                double t;
//                double alpha = 0.5;
//                for (int i = 0; i < x.Length; i++)
//                {
//                    t = Convert.ToDouble(i);
//                    w[i] = alpha * (1 - alpha) * Math.Cos(Math.PI * t / T);
//                }

//                for (int i = 0; i < x.Length; i++)
//                {
//                    hann[i] = w[i] * x[i];
//                }


//                return hann;

//            }

//            public static double[] get_hamming_windowed_ts(double[] x)
//            {
//                double[] w = new double[x.Length];
//                double[] hamming = new double[x.Length];
//                double T = x.Length;
//                double t;
//                double alpha = 0.54;
//                for (int i = 0; i < x.Length; i++)
//                {
//                    t = Convert.ToDouble(i);
//                    w[i] = alpha * (1-alpha)*Math.Cos(Math.PI * t/T);
//                }

//                for (int i = 0; i < x.Length; i++)
//                {
//                    hamming[i] = w[i] * x[i];
//                }


//                return hamming;

//            }

//            public static double[] get_parzen_windowed_ts(double[] x)
//            {
//                // special form from Hartmann notes
//                double[] w = new double[x.Length];
//                double[] parzen = new double[x.Length];
//                double T = x.Length;
//                double t;
//                for (int i = 0; i < x.Length/2; i++)
//                {
//                    t = Convert.ToDouble(i);
//                    w[i] = 1-6*Math.Pow(t/T,2)+6*Math.Pow(Math.Abs(t)/T,3);
//                }

//                for (int i = x.Length/2; i < x.Length; i++)
//                {
//                    t = Convert.ToDouble(i);
//                    w[i] = 2 * Math.Pow(1 - Math.Abs(t) / T, 3);
//                }

//                for (int i = 0; i < x.Length; i++)
//                {
//                    parzen[i] = w[i] * x[i];
//                }


//                return parzen;

//            }

//            public static double[] get_dft_spectrum(double[] x, int n, double delt, double T, bool overlap)
//            {
//                // n = number of chucks to subdivide the time series
//                if(n==0)
//                {
//                    n = n + 1;
//                }
//                int chunk_length = 0;
//                double period_chunk = T;
//                double chunk_length_int_test;
//                // check for integer length of chunks // this needs to be moved ousideo of this method
//                if (overlap)
//                {
//                    chunk_length_int_test = 2 * x.Length / (n + 1);
//                }
//                else
//                {
//                    chunk_length_int_test = x.Length / n;
//                }

//                if (chunk_length_int_test != Math.Round(chunk_length_int_test))
//                {
//                    MessageBox.Show("Time chunks must have an integer length. Try a different number of time chunks");
//                    Application.Exit();
//                }
//                else
//                {
//                    chunk_length = Convert.ToInt32(chunk_length_int_test);
//                }

//                period_chunk = delt * (chunk_length - 1);
//                //int n = 2*x.Length/chunk_length -1;
//                double[,] ts_chunks = new double[n, chunk_length];
//                double[] ts = new double[chunk_length];

//                int chunk_start = 0;
//                int chunk_end = chunk_start + chunk_length - 1;
//                int count = 0;

//                // check if overlapping is applied
//                int overlap_factor = 1; // no overlap
//                if (overlap)
//                {
//                    overlap_factor = 2; // overlap by half chunk length
//                }
//                for (int i = 0; i < n; i++)
//                {
//                    if (i == 0)
//                    {
//                        chunk_start = 0;
//                        chunk_end = chunk_start + chunk_length - 1;
//                    }
//                    else
//                    {
//                        chunk_start = chunk_start + chunk_length / overlap_factor;
//                        chunk_end = chunk_end + chunk_length / overlap_factor;
//                    }
//                    count = 0;
//                    for (int t = chunk_start; t <= chunk_end; t++)
//                    {
//                        ts_chunks[i, count] = x[t];
//                        count++;
//                    }
//                }

//                double[] spectrum = new double[chunk_length / 2]; // number of spectral estimates is N/2
//                double[,] spectra = new double[n, chunk_length / 2];
//                double[] wave_number_power = new double[n];
//                for (int i = 0; i < n; i++)
//                {
//                    for (int t = 0; t < chunk_length; t++)
//                    {
//                        ts[t] = ts_chunks[i, t];
//                    }

//                    spectrum = get_fft_by_coefficients(ts, delt, period_chunk);
//                    for (int k = 0; k < chunk_length / 2; k++)
//                    {
//                        spectra[i, k] = spectrum[k];
//                    }
//                }

//                double[] k_values = new double[n];
//                double k_avg = 0;
//                double[] spectra_avg = new double[chunk_length / 2]; // number of spectral estimates is N/2

//                for (int k = 0; k < chunk_length / 2; k++) // number of spectral estimates is N/2
//                {
//                    for (int i = 0; i < n; i++)
//                    {
//                        k_values[i] = spectra[i, k];
//                        k_avg = CStatsFactory.get_mean(k_values);
//                    }
//                    spectra_avg[k] = k_avg;
//                }

//                return spectra_avg;
//            }
//        }

//        public class CSSAFactory
//        {
//            public static double[,] prepare_embedded_matrix(double[] x, int M)
//            {
//                int N = x.Length;

//                double[,] X = new double[M, N - M + 1];
//                for (int m = 0; m < M; m++)
//                {
//                    for (int n = 0; n < N - M + 1; n++)
//                    {
//                        X[m, n] = x[n + m];
//                    }
//                }
//                //double[,] X = new double[N - M + 1, M];
//                //for (int n = 0; n < N - M + 1; n++)
//                //{
//                //    for (int m = 0; m < M; m++)
//                //    {
//                //        X[n, m] = x[n + m];
//                //    }
//                //}
//                return X;
//            }

//            public static double[] get_reconstructed_components(double[,] eofs, double[,] pcs, int n)
//            {
//                // n is the number of the component for reconstruction 

//                int M = eofs.GetLength(0); // length of embedding dimension
//                int N = pcs.GetLength(0); // Ndata-M+1 of Broomhead and King
//                int Ndata = pcs.GetLength(0) + M - 1; // length of the original time series

//                double[] q = new double[Ndata]; // array for the rc

//                for (int i = 0; i < M - 1; i++)
//                {
//                    q[i] = 0;


//                    for (int j = 0; j <= i; j++)
//                    {
//                        q[i] = q[i] + pcs[i - j, n] * eofs[j, n];
//                    }
//                    q[i] = q[i] / (i + 1);
//                }

//                for (int i = M - 1; i < N; i++)
//                {
//                    q[i] = 0;
//                    for (int j = 0; j < M; j++)
//                    {
//                        q[i] = q[i] + pcs[i - j, n] * eofs[j, n];
//                    }
//                    q[i] = q[i] / M;
//                }

//                for (int i = N; i < Ndata; i++)
//                {
//                    q[i] = 0;
//                    for (int j = i - Ndata + M; j < M; j++)
//                    {
//                        q[i] = q[i] + pcs[i - j, n] * eofs[j, n];
//                    }
//                    q[i] = q[i] / (Ndata - i + 2);
//                }

//                //for (int i = 1; i <= M - 1; i++)
//                //{
//                //    q[i - 1] = 0;
//                //    for (int j = 1; j <= i; j++)
//                //    {
//                //        q[i - 1] = q[i - 1] + pcs[i - j, n] * eofs[j - 1, n];
//                //    }
//                //    q[i - 1] = q[i - 1] / (i);
//                //}

//                //for (int i = M; i <= N; i++)
//                //{
//                //    q[i - 1] = 0;
//                //    for (int j = 1; j <= M; j++)
//                //    {
//                //        q[i - 1] = q[i - 1] + pcs[i - j, n] * eofs[j - 1, n];
//                //    }
//                //    q[i - 1] = q[i - 1] / M;
//                //}

//                //for (int i = N + 1; i <= Ndata; i++)
//                //{
//                //    q[i - 1] = 0;
//                //    for (int j = i - Ndata + M; j <= M; j++)
//                //    {
//                //        q[i - 1] = q[i - 1] + pcs[i - j, n] * eofs[j - 1, n];
//                //    }
//                //    q[i - 1] = q[i - 1] / (Ndata - i + 1);
//                //}
//                return q;

//            }

//            public static double[,] get_BK_covariance(double[,] x)
//            {
//                int M = x.GetLength(0);
//                double[,] CD = new double[M, M];

//                return CD;
//            }


//        }

//    }


//}
