﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Climate_toolkit
{
    class CPermute_factory
    {
        public static int[] get_permutation(int n, int m)
        {
            // n = number of elements to be included in the randomized output array
            // m = number of elements in the vector to be randomized.
            // n must be > than m;

            int not_done;
            int rindex;
            int indexes;

            int [] x = new int[n];

            //Random myRandom = new Random();
            for (int i = 0; i < m; i++)
            {
                not_done = 1;

                if (i == 0)
                {
                    //decimal y = myRandom.Next(1, n);
                    x[i] = AutoSeedRandoms(n);
                    //x[i] = Convert.ToInt32(Math.Floor(y * m)) + 1;
                }
                else
                {
                    while (not_done == 1)
                    {
                        //decimal z = myRandom.Next(1, n);
                        rindex = AutoSeedRandoms(n); // produce a random index

                        //rindex = Convert.ToInt32(Math.Floor(z * m) + 1);
                        //indexes = Array.Find(x, element => element.Equals(rindex));
                        indexes = Array.IndexOf(x, rindex);
                        if (indexes == -1)
                        {
                            x[i] = rindex;
                            not_done = 0;

                        }
                    }
                }
                            }
            for (int i = 0; i < m; i++)
            {
                x[i] = x[i] - 1;
            }
            return x;
        }

        // Create a random object with a timer-generated seed.
        static int AutoSeedRandoms(int n)
        {
            // Wait to allow the timer to advance.
            Thread.Sleep(1);

            Random autoRand = new Random();

            int x = RunIntNDoubleRandoms(autoRand, n);
            return x;
        }

        static int RunIntNDoubleRandoms(Random autoRand, int n)
        {
            int x = autoRand.Next(1, n+1);
            //Console.WriteLine(x.ToString());

            //Console.ReadLine();
            return x;
        }
    }
}
