﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Data.OleDb;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        // variables for sites table
        int primarykey = -1;
        string ID;
        string RawTablename;
        string Site_ID;
        string Station_name;
        string Comments;
        float LatitudeDMS;
        float LongitudeDMS;
        float LatitudeDEC;
        float LongitudeDEC;
        //string LatLong_format;
        string LatLongDMS_datum;
        string LatLongDEC_datum;
        float UTM_N;
        float UTM_E;
        int UTM_zone;
        string UTM_datum;
        string Data_type;
        string Time_units;
        string Var_units;
        string DataForm;
        
        // variables for describing data tab
        string selecteddataseriesname_describe_data;
        string selecteddataseriesname_describe_data_descriptivestatistics_table_output;

        //private void textBox_USGS_siteId_TextChanged(object sender, EventArgs e)
        //{
        //    this.Site_ID = textBox_USGS_siteId.Text;
        //}
        private void textBox_USGS_siteId_Validating(object sender, CancelEventArgs e)
        {
            this.Site_ID = textBox_describedata_USGS_siteId.Text;
        }

        private void textBox_StationName_Validating(object sender, CancelEventArgs e)
        {
            this.Station_name = textBox_describedata_USGS_siteId.Text;
        }

        //private void textBox_StationName_TextChanged(object sender, EventArgs e)
        //{
        //    this.Station_name = textBox_StationName.Text;
        //}

        private void textBox_comments_Validating(object sender, CancelEventArgs e)
        {
            this.Comments = textBox_describedata_comments.Text;
        }
        //private void textBox_comments_TextChanged(object sender, EventArgs e)
        //{

        //}

        private void textBox_latitude_Validating(object sender, CancelEventArgs e)
        {

        }
        //private void textBox_latitude_TextChanged(object sender, EventArgs e)
        //{
        //}

        private void textBox_longitude_Validating(object sender, CancelEventArgs e)
        {

        }
        //private void textBox_longitude_TextChanged(object sender, EventArgs e)
        //{

        //}

        private void textBox_utmnorthing_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.UTM_N = Convert.ToSingle(textBox_describedata_utmnorthing.Text);
            }
            catch
            {
            }
        }
        //private void textBox_utmnorthing_TextChanged(object sender, EventArgs e)
        //{

        //}

        private void textBox_utmeasting_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.UTM_E = Convert.ToSingle(textBox_describedata_utmeasting.Text);
            }
            catch
            {
            }
        }
        //private void textBox_utmeasting_TextChanged(object sender, EventArgs e)
        //{

        //}

        private void comboBox_Data_type_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.Data_type = comboBox_describedata_dataType.SelectedItem.ToString();
        }

        private void comboBox_timeunits_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.Time_units = comboBox_describedata_timeunits.SelectedItem.ToString();
        }

        private void comboBox_varUnits_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.Var_units = comboBox_describedata_varUnits.SelectedItem.ToString();
        }

        //private void comboBox_latlong_format_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    this.LatLong_format = comboBox_latlong_format.SelectedItem.ToString();
        //}

        private void comboBox_latlong_datum_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.LatLongDMS_datum = comboBox_describedata_latlongDMS_datum.SelectedItem.ToString();
        }

        private void comboBox_utmzone_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                this.UTM_zone = Convert.ToInt16(comboBox_describedata_utmzone.SelectedItem);
            }
            catch
            {
            }
        }

        private void comboBox_utmdatum_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.UTM_datum = comboBox_describedata_utmdatum.SelectedItem.ToString();
        }

        public void fill_combobox_with_datatablenames_Describe_data()
        {
            comboBox_Describe_data_series_name.Items.Clear();

            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["ID"].ToString());
                }
            }

            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["Seriesnameout"].ToString());
                }
            }

            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_Describe_data_series_name.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_Describe_data_series_name.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }
        }

        private void comboBox_Describe_data_series_name_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.selecteddataseriesname = (string)comboBox_Describe_data_series_name.SelectedItem;
            //this.selecteddataseriesname = "raw__" + this.selecteddataseriesname;
            this.selecteddataseriesname_describe_data = (string)comboBox_Describe_data_series_name.SelectedItem;
            selecteddataseriesname_describe_data_descriptivestatistics_table_output = selecteddataseriesname_describe_data + "_StatsTable";
            string dataform = null;

            // get statistics if the data is a vector, but not if it's a matrix
            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    dataform = dr["DataForm"].ToString();
                }
            }

            if (dataform == "vector")
            {
                int length;
                double mean;
                double variance;
                double stdev;
                double skew;
                double kurtosis;
                double min;
                double max;

                string[] descriptive_statistics_labels = new string[8];
                double[] descriptive_statistics_output = new double[8];

                double[] arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_describe_data, 0);
                double[] arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_describe_data, 1);

                length = arraycol1.Length;
                mean = CStatsFactory.get_mean(arraycol1);
                variance = CStatsFactory.get_variance(arraycol1, mean);
                stdev = CStatsFactory.get_stdev(arraycol1, mean);
                skew = CStatsFactory.get_skew(arraycol1, mean);
                kurtosis = CStatsFactory.get_kurtosis(arraycol1, mean);
                min = arraycol1.Min();
                max = arraycol1.Max();

                descriptive_statistics_labels[0] = "length";
                descriptive_statistics_labels[1] = "mean";
                descriptive_statistics_labels[2] = "variance";
                descriptive_statistics_labels[3] = "standard deviation";
                descriptive_statistics_labels[4] = "skew";
                descriptive_statistics_labels[5] = "kurtosis";
                descriptive_statistics_labels[6] = "min";
                descriptive_statistics_labels[7] = "max";

                descriptive_statistics_output[0] = length;
                descriptive_statistics_output[1] = mean;
                descriptive_statistics_output[2] = variance;
                descriptive_statistics_output[3] = stdev;
                descriptive_statistics_output[4] = skew;
                descriptive_statistics_output[5] = kurtosis;
                descriptive_statistics_output[6] = min;
                descriptive_statistics_output[7] = max;

                // create tables in datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_describe_data_descriptivestatistics_table_output);

                // put results into datamaster
                get_datatable_from_string_and_double(descriptive_statistics_labels, "statistic", descriptive_statistics_output, "value", selecteddataseriesname_describe_data_descriptivestatistics_table_output);

                fill_descriptivestatistics_datagridview_with_values();
            }
            else
            {
                dataGridView_descriptivestatistics.Rows.Clear();
            }
        }

        public void fill_descriptivestatistics_datagridview_with_values()
        {
            dataGridView_descriptivestatistics.Rows.Clear();
            
            string tablename = null;
            int n = 0;
            //dataGridView_descriptivestatistics.Rows.Clear();
            foreach (DataRow row in datamaster.Tables["Sites"].Rows)
            {
                if (row["ID"].ToString() == selecteddataseriesname)
                {
                    tablename = row["DescriptiveStatisticsTablename"].ToString();
                }
            }

            foreach (DataRow dr in datamaster.Tables[tablename].Rows)
            {
                dataGridView_descriptivestatistics.Rows.Add();
                dataGridView_descriptivestatistics.Rows[n].Cells[0].Value = dr[0].ToString();
                dataGridView_descriptivestatistics.Rows[n].Cells[1].Value = dr[1];
                n++;
            }
        }

        public void update_describedata_tab()
        {
            textBox_describedata_StationName.Clear();
            textBox_describedata_comments.Clear();
            textBox_describedata_latitudeDMS.Clear();
            textBox_describedata_longitudeDMS.Clear();
            textBox_describedata_latitudeDEC.Clear();
            textBox_describedata_longitudeDEC.Clear();
            textBox_describedata_utmnorthing.Clear();
            textBox_describedata_utmeasting.Clear();

            foreach(DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    textBox_describedata_StationName.Text = dr["StationName"].ToString();
                    textBox_describedata_comments.Text = dr["Comments"].ToString();

                    textBox_describedata_latitudeDMS.Text = dr["LatitudeDMS"].ToString();
                    textBox_describedata_longitudeDMS.Text = dr["LongitudeDMS"].ToString();

                    textBox_describedata_latitudeDEC.Text = dr["LatitudeDEC"].ToString();
                    textBox_describedata_longitudeDEC.Text = dr["LongitudeDEC"].ToString();

                    textBox_describedata_utmnorthing.Text = dr["UTMN"].ToString();
                    textBox_describedata_utmeasting.Text = dr["UTME"].ToString();

                    comboBox_describedata_latlongDMS_datum.SelectedItem = dr["LatlongDMSDatum"].ToString();
                    comboBox_describedata_latlongDEC_datum.SelectedItem = dr["LatlongDECDatum"].ToString();
                    comboBox_describedata_utmdatum.SelectedItem = dr["UTMDatum"].ToString();

                    comboBox_describedata_utmzone.SelectedItem = dr["Zone"].ToString();
                    comboBox_describedata_dataType.SelectedItem = dr["DataType"].ToString();

                    comboBox_describedata_timeunits.SelectedItem = dr["TimeUnits"].ToString();
                    comboBox_describedata_varUnits.SelectedItem = dr["VarUnits"].ToString();

                }
            }
        }

        private void textBox_latitudeDEC_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.LatitudeDEC = Convert.ToSingle(textBox_describedata_latitudeDEC.Text);
            }
            catch
            {
            }
        }

        private void textBox_longitudeDEC_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.LongitudeDEC = Convert.ToSingle(textBox_describedata_longitudeDEC.Text);
            }
            catch
            {
            }
        }

        private void textBox_latitudeDMS_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.LatitudeDMS = Convert.ToSingle(textBox_describedata_latitudeDMS.Text);
            }
            catch
            {
            }
        }

        private void textBox_longitudeDMS_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.LongitudeDMS = Convert.ToSingle(textBox_describedata_longitudeDMS.Text);
            }
            catch
            {
            }
        }


    }
}
