﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//using System;
//using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
//using System.Text;
using System.Windows.Forms;
//using MathNet;
//using MathNet.Numerics.LinearAlgebra.Double;
//using MathNet.Numerics.LinearAlgebra.Double.Factorization;

//using MathNet.Numerics.LinearAlgebra.Generic;



namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        // variables for Fourier analysis

        string selecteddataseriesname_periodicanalysis_spectralanalysis_input;
        string selecteddataseriesname_periodicanalysis_spectralanalysis_output;
        string selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise;
        string selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90;
        string selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95;
        string selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99;

        string selectedwindow;
        string sig_test;

        int spectral_smoothing_width;
        int num_spectral_realizations;
        int Fourier_samping_interval;
        bool overlap = false;
        bool Fourier_exists = false;


        

        // variables for SSA analysis

        string selecteddataseriesname_periodicanalysis_SSA_input;
        string selecteddataseriesname_periodicanalysis_SSA_output;
        string selecteddataseriesname_periodicanalysis_SSA_output_spectrum;
        string selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized;
        string selecteddataseriesname_periodicanalysis_SSA_output_TEOFs;
        string selecteddataseriesname_periodicanalysis_SSA_output_TPCs;
        string selecteddataseriesname_periodicanalysis_SSA_output_RCs;
        string selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector;
        string selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector;
        string selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error;
        string selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized;

        int SSA_sampling_interval;
        int SSA_window_length;
        int SSA_select_TEOF;
        int SSA_select_TPC;
        int SSA_select_RCs;

        string SSA_error_bar_method;

        bool SSA_plot_percent_variance = false;
        bool SSA_plot_frequency = false;
        bool SSA_exists = false;
        bool RCs_exist = false;

        #region page_layout

        public void fill_combobox_with_datatablenames_spectralanalysis()
        {
            comboBox_spectralanalysis_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_spectralanalysis_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_spectralanalysis_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_spectralanalysis_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_spectralanalysis_dataseriesname.Items.Add(table.TableName);
            //                comboBox_spectralanalysis_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_spectralanalysis_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        public void fill_combobox_with_datatablenames_SSA()
        {
            comboBox_SSA_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_SSA_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_SSA_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_SSA_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_SSA_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_SSA_dataseriesname.Items.Add(table.TableName);
            //                comboBox_SSA_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_SSA_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        //public void fill_combobox_with_datatablenames_spectralanalysis()
        //{
        //    comboBox_spectralanalysis_dataseriesname.Items.Clear();
        //    foreach (DataTable table in datamaster.Tables)
        //    {
        //        if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity" & table.TableName != "periodicanalysis")
        //        {
        //            comboBox_spectralanalysis_dataseriesname.Items.Add(table.TableName);
        //        }
        //    }
        //}
        //public void fill_combobox_with_datatablenames_SSA()
        //{
        //    comboBox_SSA_dataseriesname.Items.Clear();
        //    foreach (DataTable table in datamaster.Tables)
        //    {
        //        if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity" & table.TableName != "periodicanalysis")
        //        {
        //            comboBox_SSA_dataseriesname.Items.Add(table.TableName);
        //        }
        //    }
        //}

        private void button_plot_fourier_spectrum_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster, 
                selecteddataseriesname_periodicanalysis_spectralanalysis_output, 
                selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise, 
                selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90, 
                selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95, 
                selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99, this);
            form_spectrum_plot.Show();
        }

        private void display_chunk_length()
        {
            // get length of the time series
            double[] arraycol0;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_spectralanalysis_input, 0);

            int N = arraycol0.Length;
            float N_double = Convert.ToSingle(N);
            float num_spectral_realizations_double = Convert.ToSingle(num_spectral_realizations);
            float chunk_length = arraycol0.Length;

            if (this.overlap)
            {
                chunk_length = 2 * N_double / (num_spectral_realizations_double + 1);
            }
            else
            {
                chunk_length = N_double / (num_spectral_realizations_double);
            }
            label_length_spectral_realizations.Text = "Length of spectral realization(s):" + Convert.ToString(chunk_length);
        }


        #endregion page_layout

        #region Fourier_analysis
        #region Fourier_analysis_define_inputs

        private void comboBox_spectralanalysis_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_periodicanalysis_spectralanalysis_input = (string)comboBox_spectralanalysis_dataseriesname.SelectedItem;
            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output = (string)comboBox_spectralanalysis_dataseriesname.SelectedItem;

            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output = selecteddataseriesname_periodicanalysis_spectralanalysis_output + "_stm"; // add default suffix

            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise = selecteddataseriesname_periodicanalysis_spectralanalysis_output + "_red"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90 = selecteddataseriesname_periodicanalysis_spectralanalysis_output + "_s90"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95 = selecteddataseriesname_periodicanalysis_spectralanalysis_output + "_s95"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99 = selecteddataseriesname_periodicanalysis_spectralanalysis_output + "_s99"; // add default suffix 
 
            this.textBox_seriesname_fourier_spectrum_output.Text = this.selecteddataseriesname_periodicanalysis_spectralanalysis_output;

            Fourier_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_spectralanalysis_output);
            if (Fourier_exists)
            {
                button_plot_fourier_spectrum.Enabled = true;
                button_view_Fourier_spectrum_datatable.Enabled = true;
            }
            else
            {
                button_plot_fourier_spectrum.Enabled = false;
                button_view_Fourier_spectrum_datatable.Enabled = false;
            }

            // provide some default values to fill in textboxes
            this.comboBox_spectral_analysis_window.SelectedItem = "Boxcar";
            this.comboBox_fourieranalysis_significance_test.SelectedItem = "Chi-squared";
            Fourier_samping_interval = 1;

            radioButton_average_adjacent_estimates.Enabled = false;
            radioButton_average_spectra_realizations.Enabled = false;

            //this.checkBox_fourieranalysis_normalize_variance.Checked = true;
            checkBox_use_spectral_averaging.Checked = false;
            this.textBox_spectral_smoothing_width.Enabled = false;
            this.textBox_number_spectral_realizations.Enabled = false;
            this.checkBox_overlap_spectral_realizations.Enabled = false;
            if (this.checkBox_use_spectral_averaging.Checked == false)
            {
                this.textBox_spectral_smoothing_width.Text = "1";
                this.textBox_number_spectral_realizations.Text = "1";
                this.num_spectral_realizations = 1;
                this.spectral_smoothing_width = 1;
                this.overlap = false;
            }

        }






        //private void comboBox_periodicanalysis_spectralanalysis_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        //{

        //}

        private void comboBox_spectral_analysis_window_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedwindow = (string)comboBox_spectral_analysis_window.SelectedItem;
            //ComboBox comboBox = (ComboBox)sender;
        }

        private void comboBox_fourieranalysis_significance_test_SelectedIndexChanged(object sender, EventArgs e)
        {
            sig_test = (string)comboBox_fourieranalysis_significance_test.SelectedItem;
        }

        private void textBox_spectral_smoothing_width_TextChanged(object sender, EventArgs e)
        {
            try
            {
                spectral_smoothing_width = Convert.ToInt32(textBox_spectral_smoothing_width.Text);
            }
            catch
            {
                if (textBox_spectral_smoothing_width.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_spectral_smoothing_width.Clear();
                }
            }
        }

        private void textBox_fourier_analysis_sampling_interval_TextChanged(object sender, EventArgs e)
        {

            try
            {
                Fourier_samping_interval = Convert.ToInt32(textBox_fourier_analysis_sampling_interval.Text);
            }
            catch
            {
                if (textBox_fourier_analysis_sampling_interval.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_fourier_analysis_sampling_interval.Clear();
                }
            }
        }





        private void textBox_number_spectral_realizations_TextChanged(object sender, EventArgs e)
        {
            try
            {
                num_spectral_realizations = Convert.ToInt32(textBox_number_spectral_realizations.Text);
                display_chunk_length();

            }
            catch
            {
                if (textBox_number_spectral_realizations.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_number_spectral_realizations.Clear();
                }
            }
        }

        private void checkBox_overlap_spectral_realizations_CheckedChanged(object sender, EventArgs e)
        {
            //checkBox_overlap_spectral_realizations.Checked =! checkBox_overlap_spectral_realizations.Checked;
            if (checkBox_overlap_spectral_realizations.Checked)
            {
                this.overlap = true;
                display_chunk_length();
            }
            else
            {
                this.overlap = false;
                display_chunk_length();
            }

        }

        private void button_fourier_analysis_default_settings_Click(object sender, EventArgs e)
        {
            textBox_spectral_smoothing_width.Text = "1";
            textBox_fourier_analysis_sampling_interval.Text = "1";

        }

        private void radioButton_average_adjacent_estimates_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton_average_adjacent_estimates.Checked == true)
            {
                textBox_spectral_smoothing_width.Enabled = true;

                this.textBox_number_spectral_realizations.Text = "1";
                this.num_spectral_realizations = 1;
                this.overlap = false;
            }
            else
            {
                textBox_spectral_smoothing_width.Enabled = false;
            }

            if (radioButton_average_spectra_realizations.Checked == true)
            {
                textBox_number_spectral_realizations.Enabled = true;
                checkBox_overlap_spectral_realizations.Enabled = true;
                display_chunk_length();
                // check to see if there is an integer number of data points within each time chunk

                this.textBox_spectral_smoothing_width.Text = "1";
                this.spectral_smoothing_width = 1;
            }
            else
            {
                textBox_number_spectral_realizations.Enabled = false;
                checkBox_overlap_spectral_realizations.Enabled = false;
                label_length_spectral_realizations.Text = "Length of spectral realization(s):";
            }
        }

        private void checkBox_use_spectral_averaging_CheckedChanged(object sender, EventArgs e)
        {
            //checkBox_use_spectral_averaging.Checked =! checkBox_use_spectral_averaging.Checked;
            if (checkBox_use_spectral_averaging.Checked == true)
            {
                radioButton_average_adjacent_estimates.Enabled = true;
                radioButton_average_spectra_realizations.Enabled = true;

                radioButton_average_adjacent_estimates.Checked = true;
            }
            else
            {
                radioButton_average_adjacent_estimates.Enabled = false;
                radioButton_average_spectra_realizations.Enabled = false;

                textBox_spectral_smoothing_width.Enabled = false;
                textBox_number_spectral_realizations.Enabled = false;
                checkBox_overlap_spectral_realizations.Enabled = false;
                label_length_spectral_realizations.Text = "Length of spectral realization(s):";

                this.textBox_spectral_smoothing_width.Text = "1";
                this.textBox_number_spectral_realizations.Text = "1";
                this.num_spectral_realizations = 1;
                this.spectral_smoothing_width = 1;
                this.overlap = false;
            }
        }

        #endregion Fourier_analysis_define_inputs

        #region Fourier_analysis_actions
        private void button_calculate_fourier_spectrum_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            try
            {
                double[] arraycol0;
                double[] arraycol1;

                double[] k; // wavenumbers
                double[] f; // frequencies
                double[] T; // periods

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_spectralanalysis_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_spectralanalysis_input, 1);

                int N = arraycol0.Length / 2;

                double[] spectrum;
                double[] red_noise_spectrum;
                double[] spectrum_smooth;
                double[] red_noise_spectrum_smooth;

                double[] spectrum_to_use;
                double[] red_noise_spectrum_to_use;

                int period = Fourier_samping_interval * (arraycol0.Length - 1);

                double[] x = new double[arraycol0.Length];
                double[] S = new double[arraycol0.Length];
                double[] S_subset;
                double[] sig_90 = new double[N];
                double[] sig_95 = new double[N];
                double[] sig_99 = new double[N];

                bool hamming = false;
                if (selectedwindow == "Hamming")
                {
                    hamming = true;
                }
                else
                {
                    hamming = false;
                }

                //double[] spectrum = new double[N];
                //double[] red_noise_null = new double[N];
                //double[] sig_spectrum = new double[N];

                //first remove the mean from the data and store in x
                double x_mean = CStatsFactory.get_mean(arraycol1);
                for (int i = 0; i < arraycol0.Length; i++)
                {
                    x[i] = arraycol1[i] - x_mean;
                }

                update_progress_textbox("Applying window to the data");

                if (selectedwindow == "Boxcar")
                {
                    //S = x;
                    S = CFourierAnalysisFactory.get_boxcar_window(x);
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_natural_cubic_spline";
                }

                if (selectedwindow == "Hann")
                {
                    S = CFourierAnalysisFactory.get_hann_windowed_ts(x);
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_natural_cubic_spline";
                }
                if (selectedwindow == "Hamming")
                {
                    S = CFourierAnalysisFactory.get_hamming_windowed_ts(x);
                }

                if (selectedwindow == "Parzen")
                {
                    S = CFourierAnalysisFactory.get_parzen_windowed_ts(x);
                }

                update_progress_textbox("Getting the spectrum");

                spectrum = CFourierAnalysisFactory.get_dft_spectrum(S, num_spectral_realizations, Fourier_samping_interval, period, this.overlap);

                // get theoretical red noise spectrum
                update_progress_textbox("Getting the theoretical red noise spectrum");
                
                // use a subset of the data to get the theoretical power spectrum
                int subset_length;
                if (overlap)
                {
                    subset_length = 2 * S.Length / (num_spectral_realizations + 1);
                }
                else
                {
                    subset_length = S.Length / num_spectral_realizations;
                }
                S_subset = new double[subset_length];
                for (int i = 0; i < S_subset.Length; i++)
                {
                    S_subset[i] = S[i];
                }


                red_noise_spectrum = CFourierAnalysisFactory.get_theoretical_power_spectrum(S_subset, Fourier_samping_interval, spectrum);

                // get spectral smoothing using moving average
                if (radioButton_average_adjacent_estimates.Checked == true)
                {
                    // smooth the power spectrum
                    update_progress_textbox("Smoothing the spectrum");
                    spectrum_smooth = CStatsFactory.get_moving_average(spectrum, spectral_smoothing_width);
                    red_noise_spectrum_smooth = CStatsFactory.get_moving_average(red_noise_spectrum, spectral_smoothing_width);
                    get_spectrum_xaxis(spectrum_smooth, period, out k, out f, out T);

                    spectrum_to_use = spectrum_smooth;
                    red_noise_spectrum_to_use = red_noise_spectrum_smooth;

                }
                else // get the x axis for an unsmoothed power spectrum
                {
                    get_spectrum_xaxis(spectrum, period, out k, out f, out T);

                    spectrum_to_use = spectrum;
                    red_noise_spectrum_to_use = red_noise_spectrum;
                }

                // normalize spectra variance to one
                //if (checkBox_fourieranalysis_normalize_variance.Checked == true)
                //{
                spectrum_to_use = CFourierAnalysisFactory.get_spectrum_scale_to_one(spectrum_to_use);
                red_noise_spectrum_to_use = CFourierAnalysisFactory.get_spectrum_scale_to_one(red_noise_spectrum_to_use);
                //}

                // get significance spectra
                if (sig_test == "Chi-squared")
                {

                    sig_90 = CFourierAnalysisFactory.get_sig_spectrum_chisquared(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 90, hamming);
                    sig_95 = CFourierAnalysisFactory.get_sig_spectrum_chisquared(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 95, hamming);
                    sig_99 = CFourierAnalysisFactory.get_sig_spectrum_chisquared(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 99, hamming);
                }

                if (sig_test == "F test")
                {
                    sig_90 = CFourierAnalysisFactory.get_sig_spectrum_Fstatistic(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 90, hamming);
                    sig_95 = CFourierAnalysisFactory.get_sig_spectrum_Fstatistic(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 95, hamming);
                    sig_99 = CFourierAnalysisFactory.get_sig_spectrum_Fstatistic(arraycol0, red_noise_spectrum_to_use, spectral_smoothing_width, num_spectral_realizations, 99, hamming);
                }



                // save the row in datatable

                save_row_fourier_table(selecteddataseriesname, selecteddataseriesname_periodicanalysis_spectralanalysis_input,
                selecteddataseriesname_periodicanalysis_spectralanalysis_output, Fourier_samping_interval, sig_test,
                selectedwindow, spectral_smoothing_width, num_spectral_realizations);

                update_datagridview_progress();

                // create tables in datamaster
                //get_twoCol_Datatable(selecteddataseriesname_periodicanalysis_spectralanalysis_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_spectralanalysis_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99);

                // put double [] S into a table in datamaster
                //get_datatable_from_twoColArray(k, spectrum, selecteddataseriesname_periodicanalysis_spectralanalysis_output);
                get_spectrum_datatable_from_fourColArray(k, T, f, spectrum_to_use, selecteddataseriesname_periodicanalysis_spectralanalysis_output);
                get_spectrum_datatable_from_fourColArray(k, T, f, red_noise_spectrum_to_use, selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise);
                get_spectrum_datatable_from_fourColArray(k, T, f, sig_90, selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90);
                get_spectrum_datatable_from_fourColArray(k, T, f, sig_95, selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95);
                get_spectrum_datatable_from_fourColArray(k, T, f, sig_99, selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99);

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster,
                        selecteddataseriesname_periodicanalysis_spectralanalysis_output,
                        selecteddataseriesname_periodicanalysis_spectralanalysis_output_rednoise,
                        selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig90,
                        selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig95,
                        selecteddataseriesname_periodicanalysis_spectralanalysis_output_sig99, this);
                    form_spectrum_plot.Show();
                }
                Fourier_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_spectralanalysis_output);
                if (Fourier_exists)
                {
                    button_plot_fourier_spectrum.Enabled = true;
                    button_view_Fourier_spectrum_datatable.Enabled = true;
                    update_progress_textbox("Fourier analysis complete.");
                    Cursor.Current = Cursors.Default;
                }
                else
                {
                    button_plot_fourier_spectrum.Enabled = false;
                    button_view_Fourier_spectrum_datatable.Enabled = false;
                    update_progress_textbox("Something went wrong. The Fourier analysis is not complete.");
                }
            }
            catch
            {
                Cursor.Current = Cursors.Default;
                update_progress_textbox("Something went wrong. The Fourier analysis is not complete");
                return;
            }
        }

        public static void get_spectrum_xaxis(double[] spectrum, int total_length, out double[] k, out double[] f, out double[] T)
        {
            //get wavenumbers k
            k = new double[spectrum.Length];
            for (int i = 0; i < spectrum.Length; i++)
            {
                if (i == 0)
                {
                    k[i] = 1;
                }
                else
                {
                    k[i] = k[i - 1] + 1;
                }
            }

            // get periods T
            T = new double[spectrum.Length];
            
            // get frequency f
            f = new double[spectrum.Length];

            double num_wavenumbers = Convert.ToDouble(spectrum.Length);

            for (int i = 0; i < spectrum.Length; i++)
            {
                f[i] = 0.5*(i+1)/Convert.ToDouble(spectrum.Length);
            }

            for (int i = 0; i < spectrum.Length; i++)
            {
                T[i] = total_length / k[i];
                //T[i] = 1 / f[i];
                //T[i] = spectrum.Length*2 / k[i];
            } 

            //for (int i = 0; i < spectrum.Length; i++)
            //{
            //    //f[i] = (k[i]*2*Math.PI) / num_wavenumbers; // 1 / T[i];
            //    f[i] = 1 / T[i];
            //}


            


        }
 
        private void button_view_Fourier_spectrum_datatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_periodicanalysis_spectralanalysis_output);
            form_grid.Show();
        }
        #endregion Fourier_analysis_actions

        #region Fourier_analysis_define_outputs

        #endregion Fourier_analysis_define_outputs



        #endregion Fourier_analysis

        #region Singular_spectrum_analysis
        #region SSA_define_inputs


        private void comboBox_SSA_method_SelectedIndexChanged(object sender, EventArgs e)
        {
            //selected_SSA_method = (string)comboBox_SSA_method.SelectedItem;
            if (selected_SSA_method == "Eigenanalysis of covariance matrix")
            {
                comboBox_SSA_covariance_method.Enabled = true;
            }
            else
            {
                comboBox_SSA_covariance_method.Enabled = false;
            }
            comboBox_SSA_covariance_method.Enabled = true;
        }


        private void button_SSA_default_settings_Click(object sender, EventArgs e)
        {
            textBox_SSA_sampling_interval.Text = "1";
            get_SSA_window_length();

            textBox_selectTEOF.Text = "1";
            textBox_selectTPC.Text = "1";

        }

        private void textBox_SSA_windowlength_TextChanged(object sender, EventArgs e)
        {
            try
            {
                this.SSA_window_length = Convert.ToInt32(textBox_SSA_windowlength.Text);
            }
            catch
            {
                if (textBox_SSA_windowlength.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_SSA_windowlength.Clear();
                }
            }
        }

        private void textBox_SSA_sampling_interval_TextChanged(object sender, EventArgs e)
        {
            try
            {
                SSA_sampling_interval = Convert.ToInt32(textBox_SSA_sampling_interval.Text);
            }
            catch
            {
                if (textBox_SSA_sampling_interval.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_SSA_sampling_interval.Clear();
                }
            }
        }

        private void comboBox_SSA_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_periodicanalysis_SSA_input = (string)comboBox_SSA_dataseriesname.SelectedItem;
            this.selecteddataseriesname_periodicanalysis_SSA_output = (string)comboBox_SSA_dataseriesname.SelectedItem;

            this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_var"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_er";
            this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_er_var";

            this.selecteddataseriesname_periodicanalysis_SSA_output_TEOFs = selecteddataseriesname_periodicanalysis_SSA_output + "_TEOFs"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_SSA_output_TPCs = selecteddataseriesname_periodicanalysis_SSA_output + "_TPCs"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_SSA_output_RCs = selecteddataseriesname_periodicanalysis_SSA_output + "_RCs"; // add default suffix
            this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + this.textBox_selectRCs.Text.ToString();
            this.selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + this.textBox_selectRCs.Text.ToString() + "res";

            this.textBox_seriesname_SSA_spectrum_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum;
            this.textBox_seriesname_SSA_TEOFs_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_TEOFs;
            this.textBox_seriesname_SSA_TPCs_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_TPCs;
            this.textBox_seriesname_SSA_RCs_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_RCs;
            this.textBox_seriesname_SSA_RCs_vector_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector;
            this.textBox_seriesname_SSA_residuals_vector_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector;

            // provide some default values to fill in textboxes
            SSA_sampling_interval = 1;
            checkBox_SSA_plot_percent_variance.Checked = false;
            radioButton_SSA_plot_components.Checked = true;

            get_SSA_window_length();

            comboBox_SSA_errorbars.SelectedItem = "Ghil and Mo";

            SSA_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
            if (SSA_exists)
            {
                button_plot_SSA_spectrum.Enabled = true;
                button_plotTEOFs.Enabled = true;
                button_plotTPC.Enabled = true;
                button_view_SSA_spectrum_datatable.Enabled = true;
                textBox_selectTPC.Enabled = true;
                textBox_selectTEOF.Enabled = true;
                textBox_selectRCs.Enabled = true;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = true;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = true;
                button_SSA_save_RCvector.Enabled = true;

            }
            else
            {
                button_plot_SSA_spectrum.Enabled = false;
                button_plotTEOFs.Enabled = false;
                button_plotTPC.Enabled = false;
                button_view_SSA_spectrum_datatable.Enabled = false;
                textBox_selectTPC.Enabled = false;
                textBox_selectTEOF.Enabled = false;
                textBox_selectRCs.Enabled = false;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = false;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = false;
                button_SSA_save_RCvector.Enabled = false;
            }

            RCs_exist = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
            if (RCs_exist)
            {
                button_plotRCs.Enabled = true;
                button_SSA_plot_residuals.Enabled = true;
            }
            else
            {
                button_plotRCs.Enabled = false;
                button_SSA_plot_residuals.Enabled = false;
            }

        }

        private bool change_viewdatatable(string tablename)
        {
            bool exists = false;
            foreach (DataTable dt in datamaster.Tables)
            {
                if (dt.TableName == tablename)
                {
                    exists = true;
                    return exists;
                }
                else
                {
                    exists = false;
                }
            }
            return exists;
        }

        private void get_SSA_window_length()
        {
            // get length of the time series
            double[] arraycol0;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname, 0);
            //arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);

            int N = arraycol0.Length;
            float N_double = Convert.ToSingle(N);

            float SSA_window_length_double = N_double / 10;

            SSA_window_length = Convert.ToInt32(SSA_window_length_double);
            this.textBox_SSA_windowlength.Text = SSA_window_length.ToString();
        }

        private void get_default_significance_tests()
        {
            comboBox_regression_significance_level.SelectedItem = "95";
        }

        
        private void textBox_selectTEOF_TextChanged(object sender, EventArgs e)
        {
            try
            {
                SSA_select_TEOF = Convert.ToInt32(textBox_selectTEOF.Text);
            }
            catch
            {
                if (textBox_selectTEOF.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_selectTEOF.Clear();
                }
            }
        }

        private void textBox_selectTPC_TextChanged(object sender, EventArgs e)
        {
            try
            {
                SSA_select_TPC = Convert.ToInt32(textBox_selectTPC.Text);
            }
            catch
            {
                if (textBox_selectTPC.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_selectTPC.Clear();
                }
            }
        }

        private void textBox_selectRCs_Validating(object sender, CancelEventArgs e)
        {
            // first parse out the string for integers that correspond to the different RCs
            char[] delimiters = new char[] { ',', ' ' };

            string s = textBox_selectRCs.Text;
            string rcstring = null;

            string[] rclist_string = s.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
            int[] rclist = new int[rclist_string.Length];

            try
            {
                for (int i = 0; i < rclist_string.Length; i++)
                {
                    rclist[i] = Convert.ToInt32(rclist_string[i]);
                    rcstring = rcstring+rclist[i].ToString();

                }

                // check to see if the user hasn't selected RC outside of the range of 1 to M, the embedding dimension
                // find the lowest and highest RCs requested
                int rcmax = rclist.Max();
                int rcmin = rclist.Min();
                int M = Convert.ToInt32(textBox_SSA_windowlength.Text);
                if (rcmax > M || rcmin < 1)
                {
                    MessageBox.Show("The range of RC numbers is 1 to " + M.ToString() + ". Please select different RC number(s)");
                    return;
                }

                this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + rcstring;
                this.selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + rcstring + "_res";
                this.textBox_seriesname_SSA_RCs_vector_output.Text = selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector;
                this.textBox_seriesname_SSA_residuals_vector_output.Text = selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector;
            }
            catch
            {
                MessageBox.Show("Please enter integers");
                return;
                //textBox_selectRCs.Clear();
            }
        }


        private void comboBox_SSA_errorbars_SelectedIndexChanged(object sender, EventArgs e)
        {
            //SSA_error_bar_method = comboBox_SSA_method.SelectedItem.ToString();
        }

        private void textBox_seriesname_SSA_RCs_vector_output_Validating(object sender, CancelEventArgs e)
        {
            //this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + this.textBox_selectRCs.Text.ToString();
            //this.textBox_seriesname_SSA_RCs_vector_output.Text = this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector;
            selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector = textBox_seriesname_SSA_RCs_vector_output.Text;
        }

        private void textBox_seriesname_SSA_residuals_vector_output_Validating(object sender, CancelEventArgs e)
        {
            selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector = textBox_seriesname_SSA_residuals_vector_output.Text;
        }

        private void button_SSA_save_RCvector_Click(object sender, EventArgs e)
        {
            double[] arraycol0;
            double[] arraycol1;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);
            arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 1);
            
            int n = arraycol0.Length;

            double[] rcresidual = new double[n];

            // first parse out the string for integers that correspond to the different RCs
            char[] delimiters = new char[] { ',', ' ' };

            string s = textBox_selectRCs.Text;

            string[] rclist_string = s.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
            int[] rclist = new int[rclist_string.Length];

            for (int i = 0; i < rclist_string.Length; i++)
            {
                rclist[i] = Convert.ToInt32(rclist_string[i]);
            }

            // check to see if the user hasn't selected RC outside of the range of 1 to M, the embedding dimension
            // find the lowest and highest RCs requested
            int rcmax = rclist.Max();
            int rcmin = rclist.Min();
            int M = Convert.ToInt32(textBox_SSA_windowlength.Text);
            if (rcmax > M || rcmin < 1)

            {
                MessageBox.Show("The total number of range of RC numbers is 0 to " + M.ToString() + ". Please select different RC numbers");
            }
            else
            {

                double[] rcsum = get_RCsum(rclist, selecteddataseriesname_periodicanalysis_SSA_output_RCs);

                for (int i = 0; i < n; i++)
                {
                    rcresidual[i] = arraycol1[i] - rcsum[i]; 
                }

                // put the RC(s) into datamaster

                //// assign a vector of x values for the summed RCs
                //double[] x = new double[rcsum.Length];
                //for (int i = 0; i < rcsum.Length; i++)
                //{
                //    x[i] = i;
                //}

                save_row_SSA_vectors_table(selecteddataseriesname, selecteddataseriesname_periodicanalysis_SSA_input,
                    selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector, selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector, n, n);
                
                // create a datatable in datamaster to hold this

                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector);

                // copy the values to the datatables
                get_datatable_from_twoColArray(arraycol0, rcsum, selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
                get_datatable_from_twoColArray(arraycol0, rcresidual, selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector);

                selectedseries_mostrecent = selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector;

                // add datatable to comboboxes
                fill_combobox_with_datatablenames_Describe_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_EOF();
                fill_combobox_with_datatablenames_AR();
                fill_combobox_with_datatablenames_regression_predictor();
                fill_combobox_with_datatablenames_regression_predicand();

                MessageBox.Show("The RC(s) are saved and can be exported");

                RCs_exist = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
                if (RCs_exist)
                {
                    button_plotRCs.Enabled = true;
                    button_SSA_plot_residuals.Enabled = true;
                }
                else
                {
                    button_plotRCs.Enabled = false;
                    button_SSA_plot_residuals.Enabled = false;
                }

            }
        }

        #endregion SSA_define_inputs

        #region SSA_actions
        private void button_calculate_SSA_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            
            int M = SSA_window_length;

            double[] arraycol0;
            double[] arraycol1;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);
            arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 1);

            int N = arraycol0.Length;

            double[,] X = new double[M, N - M + 1]; // embedding dimension M (rows) by N-M+1 (columns)
            double[,] XT = new double[N - M + 1, M];

            double [,] cov = new double [M , M]; // covariance matrix
            double mean; // mean of the time series
            double stdev; //standard deviation of the time series

            double[] eigenvalues = new double[M];
            double[] eigenvalues_normalized = new double[M];

            double[,] eigenvectors = new double[M, M];

            double[,] TPCs = new double[N - M + 1, N - M + 1];
            double[,] TEOFs = new double[M, M];

            double[] spectrum_error = new double[M];
            double[] spectrum_error_normalized = new double[M];

            for (int i = 0; i < M; i++)
            {
                for (int j = 0; j < M; j++)
                {
                    cov[i, j] = 0;
                }
            }

            // prepare trajectory matrix
            try
            {

                X = CSSAFactory.prepare_trajectory_matrix(arraycol1, M);
                update_progress_textbox("Getting trajectory matrix");
                alglib.ablas.rmatrixtranspose(M, N - M + 1, X, 0, 0, ref XT, 0, 0);



                //var Xvar = new DenseMatrix(X);

                //if (comboBox_SSA_method.SelectedItem.ToString() == "SVD of trajectory matrix")
                //{
                //    // do SVD on the trajectory matrix
                //    var Xsvd = Xvar.Svd(true);
                //    double[,] rightsideT = Xsvd.VT().ToArray(); // this is N' x N' array, N' = N-M+1, rows > M in nullspace
                //    eigenvectors = Xsvd.U().ToArray(); // this is M x M, M = embedding dimension
                //    double[] singularvalues = Xsvd.S().ToArray(); // this is M x N' array
                //}

                //if (comboBox_SSA_method.SelectedItem.ToString() == "Eigenanalysis of covariance matrix")
                //{
                    update_progress_textbox("Performing eigenanalysis of the covariance matrix");
                    if (comboBox_SSA_covariance_method.SelectedItem.ToString() == "Broomhead and King")
                    {
                        try
                        {// get Broomhead and King covariance matrix of the trajectory matrix
                            cov = CSSAFactory.get_BK_covariance_matrix(X);

                            // do Eigenanalysis
                            //var Cdvar = new DenseMatrix(cov);
                            eigenvalues = new double[M];
                            eigenvectors = new double[M, M];
                            //eigenvalues = get_eigenvalues(Cdvar);
                            //eigenvectors = get_eigenvectors(Cdvar);

                            CEOFFactory.get_EVD(cov, out eigenvalues, out eigenvectors);

                            //var eigvvar = new DenseMatrix(eigenvectors);
                            //var eigvvarT = eigvvar.Transpose();
                            //double[,] eigvT = eigvvarT.ToArray();
                        }
                        catch
                        {
                            update_progress_textbox("Something went wrong. The SSA is not complete");
                            Cursor.Current = Cursors.Default;
                            return;
                        }
                    }
                    if (comboBox_SSA_covariance_method.SelectedItem.ToString() == "Vautard and Ghil")
                    {
                    }
                    if (comboBox_SSA_covariance_method.SelectedItem.ToString() == "Burg")
                    {
                    }
                //}
                update_progress_textbox("Getting TEOF and TPC matrices");
                for (int i = 0; i < M; i++)
                {
                    for (int j = 0; j < M; j++)
                    {
                        TEOFs[i, j] = eigenvectors[i, j];
                    }
                }

                // Get TPCs from eigenvectors and trajectory matrix
                //double[,] tpcs = Xsvd.U().Transpose().Multiply(Xvar).Transpose().ToArray();
                //var evvar = new DenseMatrix(eigenvectors);
                //TPCs = evvar.Transpose().Multiply(Xvar).Transpose().ToArray();
                alglib.ablas.rmatrixgemm(N - M + 1, M, M, 1, XT, 0, 0, 0, eigenvectors, 0, 0, 0, 0, ref TPCs, 0, 0);

                update_progress_textbox("Getting RC matrix");
                double[,] RCs = CSSAFactory.get_reconstructed_components(TEOFs, TPCs);

                // normalize the eigenvalues for percent variance
                eigenvalues_normalized = CFourierAnalysisFactory.get_spectrum_scale_to_one(eigenvalues);

                // get frequencies of the reconstructed components
                update_progress_textbox("Getting freqencies from the RCs");
                double[] freq = get_SSA_frequencies(RCs);
                double[] SSAperiod = new double[freq.Length];
                for (int i = 0; i < freq.Length; i++)
                {
                    if (freq[i] == 0)
                    {
                        SSAperiod[i] = N;
                    }
                    else
                    {
                        SSAperiod[i] = 1 / freq[i];
                    }
                }

                //this.selecteddataseriesname_periodicanalysis_SSA_input = (string)comboBox_SSA_dataseriesname.SelectedItem;
                //this.selecteddataseriesname_periodicanalysis_SSA_output = (string)comboBox_SSA_dataseriesname.SelectedItem;

                //this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm"; // add default suffix
                //this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_var"; // add default suffix
                //this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_er";
                //this.selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized = selecteddataseriesname_periodicanalysis_SSA_output + "_SSAstm_er_var";

                //this.selecteddataseriesname_periodicanalysis_SSA_output_TEOFs = selecteddataseriesname_periodicanalysis_SSA_output + "_TEOFs"; // add default suffix
                //this.selecteddataseriesname_periodicanalysis_SSA_output_TPCs = selecteddataseriesname_periodicanalysis_SSA_output + "_TPCs"; // add default suffix
                //this.selecteddataseriesname_periodicanalysis_SSA_output_RCs = selecteddataseriesname_periodicanalysis_SSA_output + "_RCs"; // add default suffix
                //this.selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + this.textBox_selectRCs.Text.ToString();
                //this.selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector = selecteddataseriesname_periodicanalysis_SSA_output_RCs + "_" + this.textBox_selectRCs.Text.ToString() + "res";

                save_row_SSA_table(selecteddataseriesname, selecteddataseriesname_periodicanalysis_SSA_input, selecteddataseriesname_periodicanalysis_SSA_output_spectrum,
                    selecteddataseriesname_periodicanalysis_SSA_output_TEOFs, selecteddataseriesname_periodicanalysis_SSA_output_TPCs,
                    selecteddataseriesname_periodicanalysis_SSA_output_RCs, SSA_sampling_interval, SSA_window_length);

                update_datagridview_progress();
                // create tables in datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_TEOFs);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_TPCs);
                get_new_datatable_in_datamaster(selecteddataseriesname_periodicanalysis_SSA_output_RCs);

                // make a vector for x values for spectrum from 1 to number of eigenvalues
                double[] x = new double[eigenvalues.Length];
                for (int i = 0; i < eigenvalues.Length; i++)
                {
                    x[i] = i + 1;
                }

                if (comboBox_SSA_errorbars.SelectedItem.ToString() == "Ghil and Mo")
                {
                    get_error_bars_Ghil_Mo(M, eigenvalues, N, out spectrum_error);
                    get_error_bars_Ghil_Mo(M, eigenvalues_normalized, N, out spectrum_error_normalized);
                }
                if (comboBox_SSA_errorbars.SelectedItem.ToString() == "Vautard and Ghil")
                {
                    get_error_bars_Vautard_Ghil(M, eigenvalues, N, out spectrum_error);
                    get_error_bars_Vautard_Ghil(M, eigenvalues_normalized, N, out spectrum_error_normalized);
                }

                if (comboBox_SSA_errorbars.SelectedItem.ToString() == "Unal and Ghil")
                {
                    mean = CStatsFactory.get_mean(arraycol1);
                    stdev = CStatsFactory.get_stdev(arraycol1, mean);
                    get_error_bars_Unal_Ghil(M, eigenvalues, cov, stdev, N, out spectrum_error);
                    get_error_bars_Unal_Ghil(M, eigenvalues_normalized, cov, stdev, N, out spectrum_error_normalized);
                }



                get_spectrum_datatable_from_fourColArray(x, SSAperiod, freq, eigenvalues_normalized, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized);
                get_spectrum_datatable_from_fourColArray(x, SSAperiod, freq, spectrum_error_normalized, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized);
                get_spectrum_datatable_from_fourColArray(x, SSAperiod, freq, eigenvalues, selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
                get_spectrum_datatable_from_fourColArray(x, SSAperiod, freq, spectrum_error, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error);

                //get_SSA_spectrum_datatable(x, freq, SSAperiod,eigenvalues_normalized, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized, "Percent Variance");
                //get_SSA_spectrum_datatable(x, freq, SSAperiod,spectrum_error_normalized, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized, "Percent Variance");

                //get_SSA_spectrum_datatable(x, freq, SSAperiod,eigenvalues, selecteddataseriesname_periodicanalysis_SSA_output_spectrum, "Eigenvalue");
                //get_SSA_spectrum_datatable(x, freq, SSAperiod,spectrum_error, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error, "Percent Variance");

                copy2DArrayIntoDataTable(TPCs, selecteddataseriesname_periodicanalysis_SSA_output_TPCs);
                copy2DArrayIntoDataTable(TEOFs, selecteddataseriesname_periodicanalysis_SSA_output_TEOFs);
                copy2DArrayIntoDataTable(RCs, selecteddataseriesname_periodicanalysis_SSA_output_RCs);

                fill_combobox_with_datatablenames_Describe_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_AR();
                fill_combobox_with_datatablenames_regression_predictor();
                fill_combobox_with_datatablenames_regression_predicand();

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it.
                    if (SSA_plot_percent_variance == true)
                    {
                        // Open the form for plotting data. Pass the datamaster dataset to it. 
                        Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster,
                            selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized,
                            selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized, this);

                        form_spectrum_plot.Show();
                           
                        //if (SSA_plot_frequency == false)
                        //{
                        //    Form_eigen_spectrum_plot_SSA form_eigen_plot = new Form_eigen_spectrum_plot_SSA(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized, 0, 2, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized, this);
                        //    form_eigen_plot.Show();

                        //}
                        //else
                        //{
                        //    Form_eigen_spectrum_plot_SSA form_eigen_plot = new Form_eigen_spectrum_plot_SSA(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized, 1, 2, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized, this);
                        //    form_eigen_plot.Show();

                        //}
                    }
                    else
                    {
                        Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster,
                           selecteddataseriesname_periodicanalysis_SSA_output_spectrum,
                           selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error, this);

                        form_spectrum_plot.Show();
                        //if (SSA_plot_frequency == false)
                        //{
                        //    Form_eigen_spectrum_plot_SSA form_eigen_plot = new Form_eigen_spectrum_plot_SSA(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum, 0, 2, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error, this);
                        //    form_eigen_plot.Show();
                        //}
                        //else
                        //{
                        //    Form_eigen_spectrum_plot_SSA form_eigen_plot = new Form_eigen_spectrum_plot_SSA(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum, 1, 2, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error, this);
                        //    form_eigen_plot.Show();
                        //}
                    }

                }
            }
            catch
            {
                Cursor.Current = Cursors.Default;
                update_progress_textbox("Something went wrong. The SSA is not complete");
                return;
            }
            SSA_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
            if (SSA_exists)
            {
                button_plot_SSA_spectrum.Enabled = true;
                button_plotTEOFs.Enabled = true;
                button_plotTPC.Enabled = true;
                button_view_SSA_spectrum_datatable.Enabled = true;
                textBox_selectTPC.Enabled = true;
                textBox_selectTEOF.Enabled = true;
                textBox_selectRCs.Enabled = true;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = true;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = true;
                button_SSA_save_RCvector.Enabled = true;
                update_progress_textbox("SSA complete");
            }
            else
            {
                button_plot_SSA_spectrum.Enabled = false;
                button_plotTEOFs.Enabled = false;
                button_plotTPC.Enabled = false;
                button_view_SSA_spectrum_datatable.Enabled = false;
                textBox_selectTPC.Enabled = false;
                textBox_selectTEOF.Enabled = false;
                textBox_selectRCs.Enabled = false;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = false;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = false;
                button_SSA_save_RCvector.Enabled = false;
                Cursor.Current = Cursors.Default;
                update_progress_textbox("Something went wrong. The SSA is not complete");
            }
            RCs_exist = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
            if (RCs_exist)
            {
                button_plotRCs.Enabled = true;
                button_SSA_plot_residuals.Enabled = true;
            }
            else
            {
                button_plotRCs.Enabled = false;
                button_SSA_plot_residuals.Enabled = false;
            }
            Cursor.Current = Cursors.Default;
        }


        private void button_view_SSA_spectrum_datatable_Click(object sender, EventArgs e)
        {
            if (SSA_plot_percent_variance == true)
            {
                // Open the form for plotting data. Pass the datamaster dataset to it. 
                Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized);
                form_grid.Show();
            }
            else
            {
                // Open the form for plotting data. Pass the datamaster dataset to it. 
                Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
                form_grid.Show();
            }
        }

        private void checkBox_SSA_plot_percent_variance_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_SSA_plot_percent_variance.Checked)
            {
                this.SSA_plot_percent_variance = true;
            }
            else
            {
                this.SSA_plot_percent_variance = false;
            }
        }

        static private double[] get_SSA_frequencies(double[,] rcs)
        {

            
            int ndata = rcs.GetLength(0);
            double ndata_double = Convert.ToDouble(ndata);
            int M = rcs.GetLength(1);

            double[] spectrum = new double[ndata/2];
            double[] ts = new double[ndata]; // stores each rc as a time series
            double[] freq = new double[M];

            // use discrete Fourier transform to get frequencies of the rcs

            double powermax = 0;
            for (int i = 0; i < M; i++) // loop along each rc
            {
                for (int j = 0; j < ndata; j++)
                {
                    ts[j] = rcs[j, i];
                }
                spectrum = CFourierAnalysisFactory.get_dft_by_coefficients(ts, 1, ndata_double);
                var k = spectrum.ToList().IndexOf(spectrum.Max());

                freq[i] = (k + 1)/ ndata_double;
            }
            return freq;

            //// use MEM to get frequencies of the rcs
            //// MEM variables
            //int MEM_no_frequencies = 256;
            //// assign MEM order
            //int MEM_order = 20;

            //if (ndata >= 200)
            //{
            //    MEM_order = 100;
            //}
            //if (ndata >= 100 & ndata < 200)
            //{
            //    MEM_order = 50;
            //}

            //if (ndata >= 80 & ndata < 100)
            //{
            //    MEM_order = 40;
            //}
            //if (ndata >= 60 & ndata < 80)
            //{
            //    MEM_order = 30;
            //}    
            //if (ndata >= 40 & ndata < 60)
            //{
            //    MEM_order = 20;
            //}
            //if (ndata >= 20 & ndata < 40)
            //{
            //    MEM_order = 10;
            //}

            //double MEM_sampling_interval = 1.0;
            //double[] f_delta = new double[MEM_no_frequencies];
            //double[] f = new double[MEM_no_frequencies];
            //double[] a = new double[MEM_order];
            //double sig2;
            //double f_inc = 1 / Convert.ToDouble(MEM_no_frequencies) / MEM_sampling_interval;
            

            //// get frequencies for MEM
            //for (int i = 0; i < MEM_no_frequencies; i++) // set the number of frequencies for MEM to 256
            //{
            //    if (i == 0)
            //    {
            //        f_delta[i] = f_inc * .5;
            //    }
            //    else
            //    {
            //        f_delta[i] = f_delta[i - 1] + f_inc * .5;
            //    }
            //}

            ////for (int i = 0; i < spectrum.Length; i++)
            ////{
            ////    f[i] = 0.5 * i / Convert.ToDouble(spectrum.Length);
            ////}

            //double powermax = 0;
            //for (int i = 0; i < M; i++) // loop along each rc
            //{
            //    for (int j = 0; j < ndata; j++)
            //    {
            //        ts[j] = rcs[j, i];
            //    }
            //    //spectrum = CFourierAnalysisFactory.get_dft_by_coefficients(ts, 1, ndata_double);
            //    a = CMEM_factory.get_Burg_AR_coeff(ts, MEM_order, out sig2);
            //    spectrum = CMEM_factory.get_MEM_spectrum(a, f_delta, sig2, MEM_sampling_interval, MEM_order, MEM_no_frequencies);
            //    var k = spectrum.ToList().IndexOf(spectrum.Max());

            //    freq[i] = f_delta[k];

            //    //freq[i] = k / ndata_double;
            //}
            //return freq;



        }

        static private void get_error_bars_Ghil_Mo(int m, double[] eig, int ndat, out double[] err)
        {
            // modifed from code for SSA Toolkit 3.1.2
            // by Chris Strong, Bill Wiebel, Mike Dettinger, Michael Ghil, Pascal Yiou, Myles Allen
            // Adapted from code by C. Penland, and Mike Dettinger

            // m: window length
            // eig: vector of eigenvalues
            // ndat: total length of the time series
            // err: vector of error bar magnitudes
            // err_upper, err_lower: values of the upper and lower error bars

            double m_double = Convert.ToDouble(m);
            double ndat_double = Convert.ToDouble(ndat);

            err = new double[eig.Length];
            
            //err_upper = new double[eig.Length];
            //err_lower = new double[eig.Length];

            for (int i = 0; i < m; i++)
            {
                err[i] = eig[i] * Math.Sqrt(m_double / (2 * ndat_double));
            //    err_upper[i] = eig[i] + err[i];
            //    err_lower[i] = eig[i] - err[i];
            }
        }

        static private void get_error_bars_Vautard_Ghil(int m, double[] eig, int ndat, out double[] err)
        {
            // Vautard and Ghil, 1989, Singular Spectrum analysis in nonlinear dynamics, with
            // applications to paleoclimatic time series, Physical D (1989), 395-424.

            // modifed from code for SSA Toolkit 3.1.2
            // by Chris Strong, Bill Wiebel, Mike Dettinger, Michael Ghil, Pascal Yiou, Myles Allen
            // Adapted from code by C. Penland, and Mike Dettinger

            // m: window length
            // eig: vector of eigenvalues
            // ndat: total length of the time series
            // err: vector of error bar magnitudes
            // err_upper, err_lower: values of the upper and lower error bars

            double m_double = Convert.ToDouble(m);
            double ndat_double = Convert.ToDouble(ndat);

            err = new double[eig.Length];

            //err_upper = new double[eig.Length];
            //err_lower = new double[eig.Length];

            for (int i = 0; i < m; i++)
            {
                err[i] = eig[i] * Math.Sqrt(2/ndat_double);
                //    err_upper[i] = eig[i] + err[i];
                //    err_lower[i] = eig[i] - err[i];
            }
        }

        static private void get_error_bars_Unal_Ghil(int m, double[] eig, double [,] cov, double stdev, int ndat, out double[] err)
        {
             //Unal and Ghil, 1995, Interannual and interdecadal oscillation patterns in sea level, Clim. Dynamics, 11, 255-278.

             //modifed from code for SSA Toolkit 3.1.2
             //by Chris Strong, Bill Wiebel, Mike Dettinger, Michael Ghil, Pascal Yiou, Myles Allen
             //Adapted from code by C. Penland, and Mike Dettinger

             //m: window length
             //eig: vector of eigenvalues
             //cov: covariance matrix
             //stdev: standard deviation
             // tau = decorrelation time

             //ndat: total length of the time series
             //err: vector of error bar magnitudes
             //err_upper, err_lower: values of the upper and lower error bars

            double tau = 1 / cov[1, 0] / stdev / stdev;
            double ndat_double = Convert.ToDouble(ndat);
            err = new double[eig.Length];

            for (int i = 0; i < m; i++)
            {
                err[i] = eig[i] * Math.Sqrt(2 *tau * 2 / ndat_double);
                //    err_upper[i] = eig[i] + err[i];
                //    err_lower[i] = eig[i] - err[i];
            } 

        }


        private void button_plot_SSA_spectrum_Click(object sender, EventArgs e)
        {
            try
            {
                if (SSA_plot_percent_variance == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster,
                        selecteddataseriesname_periodicanalysis_SSA_output_spectrum_normalized,
                        selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error_normalized, this);

                    form_spectrum_plot.Show();

                }
                else
                {
                    Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster,
                       selecteddataseriesname_periodicanalysis_SSA_output_spectrum,
                       selecteddataseriesname_periodicanalysis_SSA_output_spectrum_error, this);

                    form_spectrum_plot.Show();

                }
            }
            catch
            {

            }
            
        }

        private void button_plotTEOFs_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            try
            {
                int y = Convert.ToInt32(textBox_selectTEOF.Text);
                Form_plot_matrix form_plot_matrix = new Form_plot_matrix(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_TEOFs, y, this);

                form_plot_matrix.Show();
            }
            catch
            {
            }
        }

        private void button_plotTPC_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            try
            {
                int y = Convert.ToInt32(textBox_selectTPC.Text);
                Form_plot_matrix form_plot_matrix = new Form_plot_matrix(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_TPCs, y, this);

                form_plot_matrix.Show();
            }
            catch
            {
            }
        }

        private void button_plotRCs_Click(object sender, EventArgs e)
        {
            // first parse out the string for integers that correspond to the different RCs
            char[] delimiters = new char[] { ',', ' '};
            
            string s = textBox_selectRCs.Text;

            string[] rclist_string = s.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
            int[] rclist = new int[rclist_string.Length];

            for(int i = 0; i< rclist_string.Length; i++)
            {
                rclist[i] = Convert.ToInt32(rclist_string[i]);
            }
            try
            {
                // check to see if the user hasn't selected RC outside of the range of 1 to M, the embedding dimension
                // find the lowest and highest RCs requested
                int rcmax = rclist.Max();
                int rcmin = rclist.Min();
                int M = Convert.ToInt32(textBox_SSA_windowlength.Text);
                if (rcmax > M || rcmin < 1)
                {
                    MessageBox.Show("The total number of range of RC numbers is 0 to " + M.ToString() + ". Please select different RC numbers");
                }
                else
                {
                    double[] rcsum = get_RCsum(rclist, selecteddataseriesname_periodicanalysis_SSA_output_RCs);

                    Form_RCs_plot form_rcs_plot = new Form_RCs_plot(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, rcsum, rclist, this);
                    form_rcs_plot.Show();
                }
            }
            catch { }

        }

        private void button_SSA_plot_residuals_Click(object sender, EventArgs e)
        {
            Form_series_plot form_rcresiduals_plot = new Form_series_plot(datamaster, selecteddataseriesname_periodicanalysis_SSA_output_residuals_vector, this);
            form_rcresiduals_plot.Show();
        }

        private double[] get_RCsum(int [] rclist, string selectedRCmatrix)
        {
                   // add the selected RCs together
            double [] rc;
            rc = get_oneColArray_from_datatable(datamaster, selectedRCmatrix, rclist[0]-1);
            double[,] rcs = new double[rclist.Length, rc.Length];    
            for (int i = 0; i < rclist.Length; i++)
            {
                rc = get_oneColArray_from_datatable(datamaster, selectedRCmatrix, rclist[i]-1);
                for (int j = 0; j < rc.Length; j++)
                {
                    rcs[i, j] = rc[j];
                }
            }

            double[] rcsum = new double[rc.Length];

            for (int j = 0; j < rc.Length; j++)
            {
                for (int i = 0; i < rclist.Length; i++)
                {
                    rcsum[j] = rcsum[j] + rcs[i,j];
                }
            }
            return rcsum;
        }


        private void radioButton_SSA_plot_frequencies_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton_SSA_plot_frequencies.Checked == true)
            {
                SSA_plot_frequency = true;
            }
            else
            {
                SSA_plot_frequency = false;
            }
        }


        #endregion SSA_actions

        #region SSA_define_outputs

        #endregion SSA_define_outputs





        #endregion Singular_spectrum_analysis







    }
}
