﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Data;

namespace Climate_toolkit
{
    public class CImportDataFactory
    {
        public class CExcelFactory
        // Class for reading in an excel file
        {
            //DataTable table1 = new DataTable();
            //public DataTable importExcelFileData()
            //{
            //    DataTable dtable = new DataTable();
            //    Form_openExcel openExcel = new Form_openExcel();
            //    openExcel.Show();
            //    return dtable;

            //    // need to get the name of a file from the form, read it, and return as DataTable

            //}
        }

        public class CCsvFactory
        {
            public string GetCsvFilename()
            {
                string csvfilename = "";
                OpenFileDialog openFileDialog1 = new OpenFileDialog();

                openFileDialog1.InitialDirectory = "e:\\shared\\climate\\code";
                openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                openFileDialog1.FilterIndex = 2;
                openFileDialog1.RestoreDirectory = true;

                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        csvfilename = openFileDialog1.FileName;
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
                    }
                }

                return csvfilename;
            }

            //public DataTable Csvtodatatable(string File, string delimiter)
            //{

            //    string tablename;
            //    tablename = File;
            //    //The Datatable to Return
            //    DataTable tempdatatable = new DataTable(tablename);
                
            //    try
            //    {
            //        //Open the file in a stream reader.
            //        StreamReader s = new StreamReader(File);

            //        //Split the first line into the columns       
            //        string[] columns = s.ReadLine().Split(delimiter.ToCharArray());

            //        ////Add the new DataTable to the RecordSet
            //        //result.Add(TableName);

            //        //Cycle the colums, adding those that don't exist yet 
            //        //and sequencing the one that do.
            //        foreach (string col in columns)
            //        {
            //            bool added = false;
            //            string next = "";
            //            int i = 0;
            //            while (!added)
            //            {
            //                //Build the column name and remove any unwanted characters.
            //                string columnname = col + next;
            //                columnname = columnname.Replace("#", "");
            //                columnname = columnname.Replace("'", "");
            //                columnname = columnname.Replace("&", "");

            //                //See if the column already exists
            //                if (!tempdatatable.Columns.Contains(columnname))
            //                //if (!result.Tables[TableName].Columns.Contains(columnname))
            //                {
            //                    //if it doesn't then we add it here and mark it as added
            //                    tablename.Contains(columnname);
            //                    //result.Tables[TableName].Columns.Add(columnname);
            //                    added = true;
            //                }
            //                else
            //                {
            //                    //if it did exist then we increment the sequencer and try again.
            //                    i++;
            //                    next = "_" + i.ToString();
            //                }
            //            }
            //        }

            //        //Read the rest of the data in the file.        
            //        string AllData = s.ReadToEnd();

            //        //Split off each row at the Carriage Return/Line Feed
            //        //Default line ending in most windows exports.  
            //        //You may have to edit this to match your particular file.
            //        //This will work for Excel, Access, etc. default exports.
            //        //string[] rows = AllData.Split("\r\n".ToCharArray());
            //        string[] rows = AllData.Split(new string[] {"\n","\r\n"}, StringSplitOptions.RemoveEmptyEntries);

            //        //Now add each row to the Datatable        
            //        foreach (string r in rows)
            //        {
            //            //Split the row at the delimiter.
            //            string[] items = r.Split(delimiter.ToCharArray());

            //            //Add the item
            //            tempdatatable.Rows.Add(items);
            //            //tempdatatable.Tables[tablename].Rows.Add(items);

            //        }
            //    }
            //    catch (Exception ex)
            //    {
            //        //Let the user know what went wrong
            //        MessageBox.Show("The file could not be read:");
            //        MessageBox.Show(ex.Message);
            //    }
            //    //Return the imported data.
            //    return tempdatatable;
            //}

            public string[] csvToString(string filename)
            {
                String[] csvData; 
                //no try/catch - add these in yourselfs or let exception happen
                csvData = File.ReadAllLines(filename);

                //if no data in file ‘manually’ throw an exception
                if (csvData.Length == 0)
                {
                    throw new Exception("CSV File Appears to be Empty");
                }

                return csvData;
            }

            
            public DataTable csvToDataTable(String [] csvData, string dataseriesname, bool isRowOneHeader)
            {

                DataTable table = new DataTable(dataseriesname);

                ////no try/catch - add these in yourselfs or let exception happen
                //String[] csvData = File.ReadAllLines(file);

                ////if no data in file ‘manually’ throw an exception
                //if (csvData.Length == 0)
                //{
                //    throw new Exception("CSV File Appears to be Empty");
                //}

                String[] headings = csvData[0].Split(',');

                //String[] headings = csvData[0].Split(',');
                
                int index = 0; //will be zero or one depending on isRowOneHeader

                if(isRowOneHeader) //if first record lists headers
                {
                    index = 1; //so we won’t take headings as data
   
                    //for each heading
                    for(int i = 0; i < headings.Length; i++)
                    {
                        //replace spaces with underscores for column names
                        headings[i] = headings[i].Replace(" ", "_");

                       //add a column for each heading
                        table.Columns.Add(headings[i], typeof(string));
                   } 
                }
                else //if no headers just go for col1, col2 etc.
                {
                    for (int i = 0; i < headings.Length; i++)
                    {
                       //create arbitary column names
                       table.Columns.Add("col"+(i+1).ToString(), typeof(string));
                    }
                }

                //populate the DataTable
                for (int i = index; i < csvData.Length; i++)
                {
                    //create new rows
                    DataRow row = table.NewRow();

                    for (int j = 0; j < headings.Length; j++)
                    {
                         //fill them
                        //row[j] = csvData[i].Split({"\n","\r\n"}, StringSplitOptions.RemoveEmptyEntries)[j];
                        ////row[j] = csvData[i].Split(new string[] { "\n", "\r\n" }, StringSplitOptions.RemoveEmptyEntries)[j];

                        row[j] = csvData[i].Split(',')[j];

                    }

                    //add rows to over DataTable
                    table.Rows.Add(row);
                }

                //return the DataTable
                return table;

            } 















































            //    //Open the file in a stream reader.
            //    StreamReader s = new StreamReader(File);


            //    //Split the first line into the columns       
            //    string[] columns = s.ReadLine().Split(delimiter.ToCharArray());

            //    //Add the new DataTable to the RecordSet
            //    result.Tables.Add(TableName);

            //    //Cycle the colums, adding those that don't exist yet 
            //    //and sequencing the one that do.
            //    foreach (string col in columns)
            //    {
            //        bool added = false;
            //        string next = "";
            //        int i = 0;
            //        while (!added)
            //        {
            //            //Build the column name and remove any unwanted characters.
            //            string columnname = col + next;
            //            columnname = columnname.Replace("#", "");
            //            columnname = columnname.Replace("'", "");
            //            columnname = columnname.Replace("&", "");

            //            //See if the column already exists
            //            if (!result.Tables[TableName].Columns.Contains(columnname))
            //            {
            //                //if it doesn't then we add it here and mark it as added
            //                result.Tables[TableName].Columns.Add(columnname);
            //                added = true;
            //            }
            //            else
            //            {
            //                //if it did exist then we increment the sequencer and try again.
            //                i++;
            //                next = "_" + i.ToString();
            //            }
            //        }
            //    }

            //    //Read the rest of the data in the file.        
            //    string AllData = s.ReadToEnd();

            //    //Split off each row at the Carriage Return/Line Feed
            //    //Default line ending in most windows exports.  
            //    //You may have to edit this to match your particular file.
            //    //This will work for Excel, Access, etc. default exports.
            //    string[] rows = AllData.Split("\r\n".ToCharArray());

            //    //Now add each row to the DataSet        
            //    foreach (string r in rows)
            //    {
            //        //Split the row at the delimiter.
            //        string[] items = r.Split(delimiter.ToCharArray());

            //        //Add the item
            //        result.Tables[TableName].Rows.Add(items);
            //    }

            //    //Return the imported data.
            //    return result;
            //}











            //String line;

            //public string importCsvFileData()
            //{
            //    Stream myStream = null;
            //    OpenFileDialog openFileDialog1 = new OpenFileDialog();

            //    openFileDialog1.InitialDirectory = "e:\\shared\\climate\\code";
            //    openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            //    openFileDialog1.FilterIndex = 2;
            //    openFileDialog1.RestoreDirectory = true;

            //    if (openFileDialog1.ShowDialog() == DialogResult.OK)
            //    {
            //        try
            //        {
            //            if ((myStream = openFileDialog1.OpenFile()) != null)
            //            {
            //                try
            //                {
            //                    // Declare new list
            //                    List<string> lines = new List<string>();

            //                    using (StreamReader sr = new StreamReader(myStream))
            //                    {

            //                        // Read and display lines from the file until the end of the file is reached
            //                        while ((line = sr.ReadLine()) != null)
            //                        {
            //                            MessageBox.Show(line);
            //                            lines.Add(line);
            //                        }
            //                        sr.Close();
            //                    }
            //                }
            //                catch (Exception ex)
            //                {
            //                    //Let the user know what went wrong
            //                    MessageBox.Show("The file could not be read:");
            //                    MessageBox.Show(ex.Message);
            //                }
            //            }
            //        }
            //        catch (Exception ex)
            //        {
            //            MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
            //        }

            //    }
            //    return line;
            //}
        }
        public class CAccessFactory
        {
        }
    }
}
