﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Data.OleDb;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        #region page_layout
        bool interp_exists;
        bool standardize_exists;
        bool cdep_exists;


        private void comboBox_preprocess_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.selecteddataseriesname_preprocess = (string) "raw__"+comboBox_preprocess_dataseriesname.SelectedItem;
            //this.selecteddataseriesname_preprocess_interpolate = selecteddataseriesname_preprocess + " interpolated";
            //this.selecteddataseriesname_preprocess_standardize = selecteddataseriesname_preprocess + " standardized";
            //this.textBox_seriesname_interpolation_output.Text = this.selecteddataseriesname_preprocess_interpolate.Substring(5,selecteddataseriesname_preprocess_interpolate.Length-5);
            //this.textBox_seriesname_standardize_output.Text = this.selecteddataseriesname_preprocess_standardize.Substring(5, selecteddataseriesname_preprocess_standardize.Length - 5);
        }
        public void fill_combobox_with_datatablenames_interpolate_data()
        {
            
            comboBox_preprocessdata_interpolate_dataseriesname.Items.Clear();

            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_interpolate_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

        }

        public void fill_combobox_with_datatablenames_standardize_data()
        {
            comboBox_preprocessdata_standardize_dataseriesname.Items.Clear();

            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_standardize_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}


            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_preprocessdata_standardize_dataseriesname.Items.Add(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        public void fill_combobox_with_datatablenames_cumulative_departure()
        {
            comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}


            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_preprocessdata_cumulative_depature_dataseriesname.Items.Add(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selecteddataseriesname;
        }



        #endregion page_layout

        #region interpolation
        #region interpolation_define_inputs

        
        
        private void button_interpolate_details_Click(object sender, EventArgs e)
        {
            if (selecteddataseriesname_preprocess_interpolate_input != null)
            {
                Form_interpolation_details form_interp_details = new Form_interpolation_details(datamaster, this, selecteddataseriesname_preprocess_interpolate_input, selectedinterpmethod); //,interp_startdate,interp_enddate,interp_numpoints);
                form_interp_details.Show();
            }
            else
            {
                MessageBox.Show("Please select a data series first");
            }
        }

        public bool get_plot_status
        {
            set { showplot = value; }
        }

        public double get_interp_startdate
        {
            set { interp_startdate = value; }
        }

        public double get_interp_enddate
        {
            set { interp_enddate = value; }
        }

        public int get_interp_numpoints
        {
            set { interp_numpoints = value;} 
        }
        public double get_fp0
        {
            set { fp0 = value; }
        }

        public double get_fpn
        {
            set { fpn = value; }
        }
        private void comboBox_preprocessdata_interpolate_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.selecteddataseriesname_preprocess_interpolate_input = (string)"raw__" + comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem;
            this.selecteddataseriesname_preprocess_interpolate_input = (string)comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem;
            this.selecteddataseriesname_preprocess_interpolate_output = (string)comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem;

            this.selecteddataseriesname_preprocess_interpolate_output = selecteddataseriesname_preprocess_interpolate_output + "_int"; // add default suffix
            this.textBox_seriesname_interpolation_output.Text = this.selecteddataseriesname_preprocess_interpolate_output;

            //this.selecteddataseriesname_preprocess_interpolate_output = "pre__" + this.selecteddataseriesname_preprocess_interpolate_output; // add prefix
            comboBox_preprocess_interpolation_method.SelectedItem = "Akima Spline";

            interp_exists = change_viewdatatable(selecteddataseriesname_preprocess_interpolate_output);
            if (interp_exists)
            {
                button_plot_interpolated_data.Enabled = true;
                button_view_interpolated_datatable.Enabled = true;
            }
            else
            {
                button_plot_interpolated_data.Enabled = false;
                button_view_interpolated_datatable.Enabled = false;
            }
        }

        private void comboBox_preprocess_interpolation_method_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            selectedinterpmethod = (string)comboBox_preprocess_interpolation_method.SelectedItem;

            // load datatable into an array for interpolation methods

            CPreprocessDataFactory.CInterpolationFactory interpolated_data = new CPreprocessDataFactory.CInterpolationFactory();

            // call method for interpolating data

            // natural cubic spline --> NaturalCubicSpline method
            interpolated_data.interpolate_data(selectedinterpmethod);
        }

        private void comboBox_preprocess_interpolate_selectdataseries_SelectedIndexChanged(object sender, EventArgs e)
        {
            //this.selecteddataseriesname_preprocess = (string)comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem;
            //this.selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess + "_interpolated";

            //this.textBox_seriesname_interpolation_output.Text = this.selecteddataseriesname_preprocess_interpolated;
        }

        #endregion interpolation_define_inputs

        #region interpolation_actions
        private void button_OK_interpolate_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] arraycol0;
                double[] arraycol1;
                double[] x;
                double[] S = new double[interp_numpoints];

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_interpolate_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_interpolate_input, 1);

                // if user wants to define start, end, interval for interpolation, 
                // need a method to create a vector of desired interpolation points
                x = CPreprocessDataFactory.CInterpolationFactory.get_intervals_for_interpolation(interp_startdate, interp_enddate, interp_numpoints);

                // need a method to loop through the desired interpolation points and fill vector of interpolated values

                if (selectedinterpmethod == "Linear Interpolation")
                {
                    for (int i = 0; i <= interp_numpoints - 1; i++)
                    {
                        S[i] = CPreprocessDataFactory.CInterpolationFactory.LinearInterpolation(arraycol0, arraycol1, x[i]);
                    }
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_natural_cubic_spline";
                }

                if (selectedinterpmethod == "Cubic Spline")
                {
                    for (int i = 0; i <= interp_numpoints - 1; i++)
                    {
                        S[i] = CPreprocessDataFactory.CInterpolationFactory.NaturalCubicSpline(arraycol0, arraycol1, x[i]);
                    }
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_natural_cubic_spline";
                }

                if (selectedinterpmethod == "Clamped Cubic Spline")
                {
                    for (int i = 0; i <= interp_numpoints - 1; i++)
                    {
                        S[i] = CPreprocessDataFactory.CInterpolationFactory.ClampedCubicSpline(arraycol0, arraycol1, fp0, fpn, x[i]);
                    }
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_clamped_cubic_spline";
                }

                if (selectedinterpmethod == "Akima Spline")
                {
                    for (int i = 0; i <= interp_numpoints - 1; i++)
                    {
                        S[i] = CPreprocessDataFactory.CInterpolationFactory.AkimaSpline(arraycol0, arraycol1, x[i]);
                    }
                    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_clamped_cubic_spline";
                }

                //if (selectedinterpmethod == "Hermite Spline")
                //{
                //    for (int i = 0; i <= interp_numpoints - 1; i++)
                //    {
                //        S[i] = CPreprocessDataFactory.CInterpolationFactory.HermiteSpline(arraycol0, arraycol1, x[i]);
                //    }
                //    //selecteddataseriesname_preprocess_interpolated = selecteddataseriesname_preprocess_to_interpolate + "_clamped_cubic_spline";
                //}

                // fill row preprocess table
                //fill_row_preprocess_table(selecteddataseriesname, selecteddataseriesname_preprocess_interpolate_output, "intp");
                

                
                save_row_interpolation_table(selecteddataseriesname, selecteddataseriesname_preprocess_interpolate_input,
                    selecteddataseriesname_preprocess_interpolate_output, selectedinterpmethod,
                    interp_startdate, interp_enddate, interp_numpoints);

                // need a method to create a table in datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_preprocess_interpolate_output);

                // need a method to put double [] S into a table in datamaster
                get_datatable_from_twoColArray(x, S, selecteddataseriesname_preprocess_interpolate_output);

                selectedseries_mostrecent = selecteddataseriesname_preprocess_interpolate_output;


                update_datagridview_progress();


                // add datatable to comboboxes
                fill_combobox_with_datatablenames_Describe_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_EOF();
                fill_combobox_with_datatablenames_AR();
                fill_combobox_with_datatablenames_regression_predictor();
                fill_combobox_with_datatablenames_regression_predicand();


                //comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem = selecteddataseriesname_preprocess_interpolate_input;

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_interpolate_output, this);
                    if (showplot == true)
                    {
                        form_plot.Show();
                    }
                    else
                    {
                        MessageBox.Show("Something went wrong. The interpolated data can't be plotted.");
                    }

                }

                interp_exists = change_viewdatatable(selecteddataseriesname_preprocess_interpolate_output);
                if (interp_exists)
                {
                    button_plot_interpolated_data.Enabled = true;
                    button_view_interpolated_datatable.Enabled = true;
                    update_progress_textbox("Interpolation complete.");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
                else
                {
                    button_plot_interpolated_data.Enabled = false;
                    button_view_interpolated_datatable.Enabled = false;
                    update_progress_textbox("Something went wrong. The interpolation is not complete.");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                update_progress_textbox("Something went wrong. The interpolation is not complete");
                MessageBox.Show("Something went wrong. The interpolation is not complete.");
                System.Windows.Forms.Cursor.Current = Cursors.Default;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_interpolate_output, this);
            if (showplot == true)
            {
                form_plot.Show();
            }
            else
            {
                MessageBox.Show("Something went wrong. The interpolated data can't be plotted.");
            }

        }

        public void change_interp_button()
        {
            if (interp_numpoints > 0)
            {
                button_OK_interpolate.Enabled = true;
            }
            else
            {
                button_OK_interpolate.Enabled = false;
            }
        }

        #endregion interpolation_actions

        #region interpolation_define_outputs

        private void textBox_seriesname_interpolation_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_preprocess_interpolate_output = textBox_seriesname_interpolation_output.Text;
        }

        //private void textBox_seriesname_interpolation_output_TextChanged(object sender, EventArgs e)
        //{

        //    //this.selecteddataseriesname_preprocess_interpolate_output = textBox_seriesname_interpolation_output.Text;
        //    //this.selecteddataseriesname_preprocess_interpolate_output = "pre__" + this.selecteddataseriesname_preprocess_interpolate_output;
        //}

        private void button_save_interpolation_Click(object sender, EventArgs e)
        {

        }

        #endregion interpolation_define_outputs



        #endregion interpolation

        #region standardize
        #region standardize_define_inputs
        private void comboBox_preprocessdata_standardize_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_preprocess_standardize_input = (string)comboBox_preprocessdata_standardize_dataseriesname.SelectedItem;
            this.selecteddataseriesname_preprocess_standardize_output = (string)comboBox_preprocessdata_standardize_dataseriesname.SelectedItem;

            this.selecteddataseriesname_preprocess_standardize_output = selecteddataseriesname_preprocess_standardize_output + "_std";
            this.textBox_seriesname_standardize_output.Text = this.selecteddataseriesname_preprocess_standardize_output;

            comboBox_preprocess_standardization_method.SelectedItem = "Normal";

            standardize_exists = change_viewdatatable(selecteddataseriesname_preprocess_standardize_output);
            if (standardize_exists)
            {
                button_plot_standardized_series.Enabled = true;
                button_datatable_znorm.Enabled = true;
            }
            else
            {
                button_plot_standardized_series.Enabled = false;
                button_datatable_znorm.Enabled = false;
            }
        }

        private void comboBox_preprocess_standardization_method_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedstandardmethod = (string)comboBox_preprocess_standardization_method.SelectedItem;
        }
        #endregion standardize_define_inputs

        #region standardize_actions
        private void button_standard_z_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
            try
            {
                int firstloop = 1;
                int secondloop = 1;
                int thirdloop = 1;

                double[, ,] A;
                double[, ,] x_array;
                double[, ,] y_array;
                double[, ,] S_array;

                double[] x_vec;
                double[] y_vec;
                double[] S_vec;

                double mean = 0;
                double variance = 0;
                double alpha = 0;
                double beta = 0;


                // this tool can standardize each value in a matrix of time series
                // first determine if the selected data series is a vector or matrix...
                // get the dimensions of the array
                foreach (DataRow dr in datamaster.Tables["sites"].Rows)
                {
                    string temp = dr["ID"].ToString();
                    if (dr["ID"].ToString() == selecteddataseriesname) // && dr["DataForm"].ToString() == "matrix")
                    {
                        string temp1 = dr["DataForm"].ToString();
                        if (dr["DataForm"].ToString() == "matrix")
                        {
                            firstloop = Convert.ToInt32(dr["Dim1"]);
                            secondloop = Convert.ToInt32(dr["Dim2"]);
                            thirdloop = Convert.ToInt32(dr["Dim3"]);

                            // get the matrix data (stored as vector) in the datatable into a 3D array
                            double[] a = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_standardize_input, 0);

                            A = get_3loop_array_data(a, firstloop, secondloop, thirdloop);


                            double[, ,] x = new double[firstloop, secondloop, thirdloop];
                            double[, ,] y = new double[firstloop, secondloop, thirdloop];
                            double[, ,] S = new double[firstloop, secondloop, thirdloop];

                            y_vec = new double[A.GetLength(2)];

                            for (int i = 0; i < firstloop; i++)
                            {
                                for (int j = 0; j < secondloop; j++)
                                {
                                    for (int k = 0; k < thirdloop; k++)
                                    {
                                        y_vec[k] = A[i, j, k];
                                    }

                                    S_vec = new double[y_vec.Length];

                                    if (selectedstandardmethod == "Normal")
                                    {
                                        S_vec = CStatsFactory.CStandardizeFactory.get_standardize_z(y_vec, out mean, out variance);
                                    }

                                    if (selectedstandardmethod == "Gamma to Normal (SPI)")
                                    {
                                        S_vec = CStatsFactory.CGammaMethodsFactory.get_gamma_Z(y_vec, out mean, out variance, out alpha, out beta);
                                    }
                                    for (int k = 0; k < thirdloop; k++)
                                    {
                                        S[i, j, k] = S_vec[k];
                                    }

                                }
                            }

                            save_row_standardize_table(selecteddataseriesname, selecteddataseriesname_preprocess_standardize_input,
                            selecteddataseriesname_preprocess_standardize_output, selectedstandardmethod,
                            mean, variance, alpha, beta);

                            get_new_datatable_in_datamaster(selecteddataseriesname_preprocess_standardize_output);
                            copy3Darray_into_Datatable_vector(S, firstloop, secondloop, thirdloop, selecteddataseriesname_preprocess_standardize_output);
                        }

                        if (dr["DataForm"].ToString() == "vector")
                        {
                            x_vec = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_standardize_input, 0);
                            y_vec = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_standardize_input, 1);

                            S_vec = new double[y_vec.Length];

                            if (selectedstandardmethod == "Normal")
                            {
                                update_progress_textbox("Getting z statistic...");
                                S_vec = CStatsFactory.CStandardizeFactory.get_standardize_z(y_vec, out mean, out variance);
                            }

                            if (selectedstandardmethod == "Gamma to Normal (SPI)")
                            {
                                update_progress_textbox("Transforming gamma distribution to normal...getting z statistic...");
                                S_vec = CStatsFactory.CGammaMethodsFactory.get_gamma_Z(y_vec, out mean, out variance, out alpha, out beta);
                            }

                            save_row_standardize_table(selecteddataseriesname, selecteddataseriesname_preprocess_standardize_input,
                                selecteddataseriesname_preprocess_standardize_output, selectedstandardmethod,
                            mean, variance, alpha, beta);

                            // create a table in datamaster to hold the results
                            get_new_datatable_in_datamaster(selecteddataseriesname_preprocess_standardize_output);

                            // put results into the table in datamaster
                            get_datatable_from_twoColArray(x_vec, S_vec, selecteddataseriesname_preprocess_standardize_output);

                        }
                    }

                    //break;

                }

                update_datagridview_progress();


                selectedseries_mostrecent = selecteddataseriesname_preprocess_standardize_output;

                // add datatable to comboboxes
                fill_combobox_with_datatablenames_Describe_data();
                fill_combobox_with_datatablenames_preprocess_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_EOF();
                fill_combobox_with_datatablenames_AR();
                fill_combobox_with_datatablenames_regression_predictor();
                fill_combobox_with_datatablenames_regression_predicand();


                //comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selecteddataseriesname_preprocess_standardize_input;

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    try
                    {
                        Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_standardize_output, this);

                        if (showplot == true)
                        {
                            form_plot.Show();
                        }
                        else
                        {
                            MessageBox.Show("Something went wrong. The standardizing is not complete. Maybe a gamma interpolation is attempted with values <= 0 ?");
                        }

                    }
                    catch
                    {
                        MessageBox.Show("Something went wrong. The standardizing is not complete. Maybe a gamma interpolation is attempted with values <= 0 ?");
                    }
                }
                standardize_exists = change_viewdatatable(selecteddataseriesname_preprocess_standardize_output);
                if (standardize_exists)
                {
                    button_plot_standardized_series.Enabled = true;
                    button_datatable_znorm.Enabled = true;
                    update_progress_textbox("Standardizing complete.");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
                else
                {
                    button_plot_standardized_series.Enabled = false;
                    button_datatable_znorm.Enabled = false;
                    update_progress_textbox("Something went wrong. The standardizing is not complete");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                update_progress_textbox("Something went wrong. The standardizing is not complete");
                MessageBox.Show("Something went wrong. The standardizing is not complete.");
                System.Windows.Forms.Cursor.Current = Cursors.Default;
            }
        }
        private void button_plot_standardized_series_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_standardize_output, this);

            try
            {
                if (showplot == true)
                {
                    form_plot.Show();
                }
                else
                {
                    MessageBox.Show("Something went wrong. The standardized data can't be plotted.");
                }
            }
            catch
            {
                MessageBox.Show("Something went wrong. The standardized data can't be plotted.");
            }
        }

        private void button_datatable_znorm_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_preprocess_standardize_output);
            form_grid.Show();
        }
        #endregion standardize_actions

        #region standardize_define_outputs
        //private void textBox_seriesname_standardize_output_TextChanged(object sender, EventArgs e)
        //{
        //    this.selecteddataseriesname_preprocess_standardize = textBox_seriesname_standardize_output.Text;
        //    //this.selecteddataseriesname_preprocess_standardize = "pre__" + this.selecteddataseriesname_preprocess_standardize;
        //}

        private void textBox_seriesname_standardize_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_preprocess_standardize = textBox_seriesname_standardize_output.Text;
        }
        #endregion standardize_define_outputs
        #endregion standardize
   
        


        #region cumulativedeparture
        #region cumulativedeparture_define_inputs
        private void comboBox_preprocessdata_cumulative_depature_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_preprocess_cumdep_input = (string)comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem;
            this.selecteddataseriesname_preprocess_cumdep_output = (string)comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem;

            this.selecteddataseriesname_preprocess_cumdep_output = selecteddataseriesname_preprocess_cumdep_output + "_cdep";
            this.textBox_dataseries_cumdep_output.Text = this.selecteddataseriesname_preprocess_cumdep_output;

            cdep_exists = change_viewdatatable(selecteddataseriesname_preprocess_cumdep_output);
            if (cdep_exists)
            {
                button_plot_cumulative_departure.Enabled = true;
                button_datatable_cumdep.Enabled = true;
            }
            else
            {
                button_plot_cumulative_departure.Enabled = false;
                button_datatable_cumdep.Enabled = false;
            }
        }


        private void checkBox_cumdep_filter_CheckedChanged(object sender, EventArgs e)
        {

        }
        #endregion cumulativedeparture_define_inputs

        #region cumulativedeparture_actions
        private void button_cumulativedeparture_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] S;
                double[] x;
                double[] y;
                double mean;

                // need to get values into a vector...
                x = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_cumdep_input, 0);
                y = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_preprocess_cumdep_input, 1);

                S = CPreprocessDataFactory.CCumulativeDepatureFactory.getCumulativeDeparture(y, out mean);
                //selecteddataseriesname_preprocess_cumdep = selecteddataseriesname_preprocess_cumdep_input + "_cumulative_departure";

                // create a table in datamaster to hold the results
                get_new_datatable_in_datamaster(selecteddataseriesname_preprocess_cumdep_output);

                // put results into the table in datamaster
                get_datatable_from_twoColArray(x, S, selecteddataseriesname_preprocess_cumdep_output);

                save_row_cumulative_departure_table(selecteddataseriesname, selecteddataseriesname_preprocess_cumdep_input,
                    selecteddataseriesname_preprocess_cumdep_output, mean);

                selectedseries_mostrecent = selecteddataseriesname_preprocess_cumdep_output;


                update_datagridview_progress();

                // add datatable to comboboxes
                fill_combobox_with_datatablenames_Describe_data();
                //fill_combobox_with_datatablenames_preprocess_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_AR();
                fill_combobox_with_datatablenames_regression_predictor();
                fill_combobox_with_datatablenames_regression_predicand();

                comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selecteddataseriesname_preprocess_cumdep_input;

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_cumdep_output, this);
                    if (showplot == true)
                    {
                        form_plot.Show();
                    }
                    else
                    {
                        MessageBox.Show("Something went wrong. The cumulative departure cannot be plotted.");
                    }
                }
                cdep_exists = change_viewdatatable(selecteddataseriesname_preprocess_cumdep_output);
                if (cdep_exists)
                {
                    button_plot_cumulative_departure.Enabled = true;
                    button_datatable_cumdep.Enabled = true;
                    update_progress_textbox("Cumulative departure complete");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
                else
                {
                    button_plot_cumulative_departure.Enabled = false;
                    button_datatable_cumdep.Enabled = false;
                    update_progress_textbox("Something went wrong. The cumulative departure is not complete");
                    System.Windows.Forms.Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                update_progress_textbox("Something went wrong. The cumulative departure is not complete");                
                MessageBox.Show("Something went wrong. The cumulative departure is not complete.");
                System.Windows.Forms.Cursor.Current = Cursors.Default;
            }
        }

        private void button_plot_cumulativedeparture_Click_1(object sender, EventArgs e)
        {

            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_preprocess_cumdep_output, this);
            if (showplot == true)
            {
                form_plot.Show();
            }
            else
            {
                MessageBox.Show("Something went wrong. The cumulative departure cannot be plotted.");
            }
        }


        private void button_datatable_cumdep_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_preprocess_cumdep);
            form_grid.Show();
        }
        #endregion cumulativedeparture_actions
  

        #region cumulativedeparture_define_outputs

        private void textBox_dataseries_cumdep_output_TextChanged_1(object sender, EventArgs e)
        {
            this.selecteddataseriesname_preprocess_cumdep = textBox_dataseries_cumdep_output.Text;
        }



        #endregion cumulativedeparture_define_outputs

        #endregion cumulativedeparture

        
     











 











    }
}
