﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_organize_series : Form
    {
        private Cdatamaster datamaster;

        public Form_organize_series(Cdatamaster datamasterToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to

            string[] rownames = new string[14];

            rownames[0] = "Interpolation";
            rownames[1] = "Standardization";
            rownames[2] = "Cumulative Departure";
            rownames[3] = "ACF";
            rownames[4] = "Differencing";
            rownames[5] = "Curve Fitting";
            rownames[6] = "Fourier Analysis";
            rownames[7] = "MEM";
            rownames[8] = "SSA";
            rownames[9] = "EOF Analysis";
            rownames[10] = "Regression and Correlation";
            rownames[11] = "CCF";
            rownames[12] = "AR modeling";
            rownames[13] = "Project Series";

            for (int i = 0; i<14; i++)
            {
                dataGridView_organizeseries.Rows.Add();
                dataGridView_organizeseries.Rows[i].Cells[0].Value = rownames[i];

            }
        }
    }
}
